      subroutine gggghn1(p1,p2,p3,p4,p,n,c1234)
      implicit none
C---calculates the amplitude squared for the process
c   g(p1)+g(p2) --> H((p5+p6)+g(p3)+g(p4)
c   with momentum 1 contracted with the vector n(mu)
c     calculated by the program gggghn.frm
c     one permutation only
      include 'constants.f'
      include 'sprods_com.f'
      integer p1,p2,p3,p4
      double precision p(mxpart,4),n(4),nDn,nDp1,nDp2,nDp3,nDp4
      double precision s123,s124,s234,s134,c1234
      nDp1=n(4)*p(p1,4)-n(3)*p(p1,3)-n(2)*p(p1,2)-n(1)*p(p1,1)
      nDp2=n(4)*p(p2,4)-n(3)*p(p2,3)-n(2)*p(p2,2)-n(1)*p(p2,1)
      nDp3=n(4)*p(p3,4)-n(3)*p(p3,3)-n(2)*p(p3,2)-n(1)*p(p3,1)
      nDp4=n(4)*p(p4,4)-n(3)*p(p4,3)-n(2)*p(p4,2)-n(1)*p(p4,1)
      nDn=n(4)**2-n(3)**2-n(2)**2-n(1)**2
c--- appropriate scale is approx 1d-3*energy(incoming)
c--- so of order(1) for the Tevatron
      if (abs(nDp1).gt.1d-3*abs(p(1,4))) then 
         write(*,*) 'Error in gggghn1 for :',p1,p2,p3,p4
         write(*,*) 'cutoff',1d-3*abs(p(1,4))
         write(6,*) 'nDp1',nDp1
         call flush(6)
         stop
      endif
      s123=s(p1,p2)+s(p2,p3)+s(p3,p1)
      s124=s(p1,p2)+s(p2,p4)+s(p4,p1)
      s234=s(p2,p3)+s(p3,p4)+s(p4,p2)
      s134=s(p1,p3)+s(p3,p4)+s(p4,p1)
      c1234=  + nDn*s123**(-2) * (  - 4.D0*s(p1,p4)**2 - 8.D0*s(p1,p4)*
     &    s(p2,p4) - 8.D0*s(p1,p4)*s(p3,p4) - 4.D0*s(p2,p4)**2 - 8.D0*
     &    s(p2,p4)*s(p3,p4) - 4.D0*s(p3,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)**2*s(p1,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)**2*s(p1,p4)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p3)**2*s(p1,p4)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)**2*s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*
     &    s(p2,p4)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p3,p4)**2 - 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2 - 8.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4)*s(p3,p4) - 4.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 - 8.D
     &    0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) - 4.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)
     &    *s(p2,p4) - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)*
     &    s(p3,p4) )
      c1234 = c1234 + nDn*s123**(-2) * (  - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*s(p3,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s124**(-1) * ( 4.D0*s(p1,p2)**2 - 
     &    4.D0*s(p1,p2)*s(p3,p4) + 12.D0*s(p1,p3)*s(p3,p4) + 12.D0*s(p1
     &    ,p4)*s(p3,p4) + 8.D0*s(p3,p4)**2 + 8.D0/(s(p1,p2))*s(p1,p3)**
     &    2*s(p3,p4) + 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) + 4.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p3,p4)**2 + 8.D0/(s(p1,p2))*s(p1,p4)**
     &    2*s(p3,p4) + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(
     &    p3,p4)**2 + 2.D0/(s(p1,p4))*s(p1,p2)**3 + 2.D0/(s(p1,p4))*s(
     &    p1,p2)**2*s(p1,p3) - 4.D0/(s(p1,p4))*s(p1,p2)**2*s(p3,p4) + 2.
     &    D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2 + 4.D0/(s(p1,p4))*s(p1,p2)
     &    *s(p3,p4)**2 + 2.D0/(s(p1,p4))*s(p1,p3)**3 + 4.D0/(s(p1,p4))*
     &    s(p1,p3)**2*s(p3,p4) + 4.D0/(s(p1,p4))*s(p1,p3)*s(p3,p4)**2
     &     - 4.D0/(s(p2,p3))*s(p1,p2)**2*s(p1,p4) - 4.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p4)**2 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p3,
     &    p4) - 2.D0/(s(p2,p3))*s(p1,p4)**3 + 4.D0/(s(p2,p3))*s(p1,p4)
     &    **2*s(p3,p4) - 4.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * ( s(p1,p2)**2 + 4.D0*
     &    s(p1,p2)*s(p1,p3) + 2.D0*s(p1,p2)*s(p1,p4) - 5.D0*s(p1,p2)*s(
     &    p2,p4) + 2.D0*s(p1,p3)**2 + 2.D0*s(p1,p3)*s(p1,p4) - 12.D0*s(
     &    p1,p3)*s(p2,p4) + 2.D0*s(p1,p4)**2 - 4.D0*s(p1,p4)*s(p2,p4)
     &     - 2.D0/(s(p1,p2))*s(p1,p3)**3 - 2.D0/(s(p1,p2))*s(p1,p3)**2*
     &    s(p1,p4) - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 - 4.D0/(s(p1,
     &    p2))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 4.D0/(s(p1,p2))*s(p1,p3)*s(
     &    p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**4 + 4.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)**3*s(p2,p4) - 4.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)**2*s(p2,p4)**2 - 2.D0/(s(p1,p4))*s(p1,p2)**2
     &    *s(p1,p3) - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2 - 6.D0/(s(p1
     &    ,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))*s(p1,p2)*
     &    s(p2,p4)**2 - 2.D0/(s(p1,p4))*s(p1,p3)**3 - 4.D0/(s(p1,p4))*
     &    s(p1,p3)*s(p2,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2
     &    *s(p1,p3)**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3
     &    )*s(p2,p4) )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * ( 4.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**3*s(p1,p3)**2 - 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)**2 + 2.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**3 - 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*s(p2,p4)
     &     + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &    *s(p2,p4)**2 + 1/(s(p2,p3))*s(p1,p2)**3 + 7.D0/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p3) + 2.D0/(s(p2,p3))*s(p1,p2)**2*s(p1,p4) - 7.
     &    D0/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) + 6.D0/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p3)**2 + 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4) - 9.
     &    D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 2.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * (  - 4.D0/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p4)*s(p2,p4) + 4.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4
     &    )**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) - 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) + 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) + 1/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3*s(p1,p3) - 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(
     &    p1,p3)**2 + 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2
     &    ,p4) - 3.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,
     &    p4) + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)**
     &    2 - 1/(s(p3,p4))*s(p1,p2)**2*s(p1,p3) - 4.D0/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)**2 + 5.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)
     &     )
      c1234 = c1234 + nDn*s123**(-1)*s234**(-1) * ( 2.D0*s(p1,p2)**2 + 
     &    3.D0*s(p1,p2)*s(p1,p3) + s(p1,p2)*s(p1,p4) + 3.D0*s(p1,p2)*s(
     &    p2,p3) + 4.D0*s(p1,p2)*s(p2,p4) + s(p1,p3)*s(p1,p4) + s(p1,p3
     &    )*s(p2,p3) - 11.D0*s(p1,p4)**2 + 4.D0*s(p1,p4)*s(p2,p3) - 4.D0
     &    *s(p1,p4)*s(p2,p4) + s(p2,p3)**2 - 1/(s(p1,p2))*s(p1,p3)**3
     &     - 2.D0/(s(p1,p2))*s(p1,p3)**2*s(p2,p3) + 5.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)**2 - 5.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,
     &    p3) + 4.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 1/(s(p1,p2
     &    ))*s(p1,p3)*s(p2,p3)**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*
     &    s(p2,p4) + 4.D0/(s(p1,p2))*s(p1,p4)**3 - 3.D0/(s(p1,p2))*s(p1
     &    ,p4)**2*s(p2,p3) + 4.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p4) - 1/(
     &    s(p1,p2))*s(p1,p4)*s(p2,p3)**2 - 4.D0/(s(p1,p2))*s(p1,p4)*s(
     &    p2,p3)*s(p2,p4) - 1/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4
     &    ) + 1/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3) - 3.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)**2 + 4.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3) )
      c1234 = c1234 + nDn*s123**(-1)*s234**(-1) * (  - 1/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p1,p4)**3 + 7.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)**2*s(p2,p3) - 3.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1
     &    ,p4)*s(p2,p3)**2 - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**4 + 4.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(p2,p3) - 2.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 - 8.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p4)*s(p2,p4) + 8.D0/(s(p2,p3))*s(p1,p4)**3 + 4.D0/(
     &    s(p2,p3))*s(p1,p4)**2*s(p2,p4) + 4.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p4)**2*s(p2,p4) + 1/(s(p3,p4))*s(p1,p2)**2*s(p1
     &    ,p4) + 1/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) + 2.D0/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*s(p1,p4) - 1/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p3) - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)**2 + 4.D0/(s(p3,p4
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p3) - 1/(s(p3,p4))*s(p1,p2)*s(p2,p3
     &    )**2 - 1/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 1/(s(p3,p4))*s(p1,
     &    p3)*s(p1,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s234**(-1) * ( 1/(s(p3,p4))*s(p1,
     &    p3)*s(p1,p4)*s(p2,p3) - 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2
     &     - 1/(s(p3,p4))*s(p1,p4)*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s123**(-1) * (  - 11.D0*s(p1,p2) - 23.D0*s(p1
     &    ,p4) - s(p2,p3) - 20.D0*s(p2,p4) - 16.D0*s(p3,p4) + 5.D0/(s(
     &    p1,p2))*s(p1,p3)**2 + 9.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4) + 1/(
     &    s(p1,p2))*s(p1,p3)*s(p2,p3) + 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,
     &    p4) + 4.D0/(s(p1,p2))*s(p1,p4)**2 + 1/(s(p1,p2))*s(p1,p4)*s(
     &    p2,p3) + 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4) - 4.D0/(s(p1,p2))*
     &    s(p1,p4)*s(p3,p4) + 8.D0/(s(p1,p2))*s(p2,p4)**2 + 8.D0/(s(p1,
     &    p2))*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)
     &    **2*s(p1,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4
     &    ) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p3,p4) + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 + 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4) + 8.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2
     &    *s(p3,p4) + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2
     &     + 8.D0/(
     & s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*s(p3,p4) - 1/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**3 - 3.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**
     &    2*s(p1,p4) + 1/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 8.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2 + 3.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) - 8.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p4)**2 - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)**3 + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3) - 8.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4) - 4.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2 + 6.D0/(s(p1,p4))*s(p1,p2)*
     &    s(p2,p4) + 4.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4) - 4.D0/(s(p1,p4)
     &    )*s(p2,p4)**2 - 12.D0/(s(p1,p4))*s(p2,p4)*s(p3,p4) - 8.D0/(s(
     &    p1,p4))*s(p3,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3) + 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) + 
     &    2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4) + 2.D0/(s(p1,
     &    p4))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4)**2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3
     &    ,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p1,p3) + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p3,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)**2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p1,p3)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)**2 - 6.D0/(s(p2,
     &    p3))*s(p1,p2)**2 - 6.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) - 4.D0/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p4) - 16.D0/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4) )
      c1234 = c1234 + nDn*s123**(-1) * (  - 8.D0/(s(p2,p3))*s(p1,p2)*s(
     &    p3,p4) + 16.D0/(s(p2,p3))*s(p1,p4)**2 + 16.D0/(s(p2,p3))*s(p1
     &    ,p4)*s(p2,p4) + 8.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4) + 12.D0/(s(
     &    p2,p3))*s(p2,p4)**2 + 20.D0/(s(p2,p3))*s(p2,p4)*s(p3,p4) + 8.D
     &    0/(s(p2,p3))*s(p3,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )**2*s(p1,p4) - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,
     &    p4) - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4) + 8.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) + 4.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) - 1/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3 + 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3) - 
     &    2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4) - 1/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p2)**2*s(p2,p4) + 3.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p2)*s(p1,p3)*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p4)**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1
     &    ,p4)*s(p2,p4) )
      c1234 = c1234 + nDn*s123**(-1) * (  - 4.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**3
     &     - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4) - 4.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2 + 5.D0/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3) - 5.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4) + 1/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p3) - 5.D0/(s(p3,p4))*s(p1,p2)*s(p2,p4)
     &     + 1/(s(p3,p4))*s(p1,p3)**2 + 2.D0/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4) + 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3) - 4.D0/(s(p3,p4))*s(
     &    p1,p4)**2 + 1/(s(p3,p4))*s(p1,p4)*s(p2,p3) - 12.D0/(s(p3,p4))
     &    *s(p1,p4)*s(p2,p4) - 4.D0/(s(p3,p4))*s(p2,p4)**2 )
      c1234 = c1234 + nDn*s124**(-2) * (  - 6.D0*s(p1,p3)**2 - 12.D0*s(
     &    p1,p3)*s(p2,p3) - 12.D0*s(p1,p3)*s(p3,p4) - 6.D0*s(p2,p3)**2
     &     - 12.D0*s(p2,p3)*s(p3,p4) - 6.D0*s(p3,p4)**2 - 4.D0/(s(p1,p2
     &    ))*s(p1,p3)**2*s(p1,p4) - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    s(p2,p3) - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 4.D0
     &    /(s(p1,p2))*s(p1,p4)*s(p2,p3)**2 - 8.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p3)*s(p3,p4) - 4.D0/(s(p1,p2))*s(p1,p4)*s(p3,p4)**2 - 2.D
     &    0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2
     &    ))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p3,p4) - 2.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p4)**2*s(p2,p3)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p4)**2*s(p3,p4)**2 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3
     &    )**2 - 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 8.D0/(s(
     &    p1,p4))*s(p1,p2)*s(p1,p3)*s(p3,p4) - 4.D0/(s(p1,p4))*s(p1,p2)
     &    *s(p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-2) * (  - 8.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p2,p3)*s(p3,p4) - 4.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4)**2 - 2.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0/(s(p1,
     &    p4))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3) - 4.D0/(s(p1,p4
     &    ))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)*s(p3,p4) - 2.D0/(s(p1,p4))
     &    /(s(p1,p4))*s(p1,p2)**2*s(p2,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,
     &    p4))*s(p1,p2)**2*s(p2,p3)*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)**2*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s134**(-1) * ( 4.D0*s(p1,p2)**2 - 
     &    4.D0*s(p1,p2)*s(p1,p3) + 4.D0*s(p1,p2)*s(p1,p4) + 4.D0*s(p1,
     &    p2)*s(p2,p3) + 12.D0*s(p1,p3)*s(p2,p3) + 4.D0*s(p1,p4)**2 - 4.
     &    D0*s(p1,p4)*s(p2,p3) + 8.D0*s(p2,p3)**2 + 2.D0/(s(p1,p2))*s(
     &    p1,p3)**3 + 2.D0/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) + 4.D0/(s(p1
     &    ,p2))*s(p1,p3)**2*s(p2,p3) + 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4
     &    )**2 + 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2 + 2.D0/(s(p1,p2))
     &    *s(p1,p4)**3 - 4.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p3) + 4.D0/(
     &    s(p1,p2))*s(p1,p4)*s(p2,p3)**2 + 8.D0/(s(p1,p4))*s(p1,p2)**2*
     &    s(p2,p3) + 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 8.D0
     &    /(s(p1,p4))*s(p1,p3)**2*s(p2,p3) + 4.D0/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p3)**2 + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p3)**2 - 2.D0/(s(p3,p4))*s(p1,p2)**3 + 4.D0/(s(p3,p4))*s(
     &    p1,p2)**2*s(p1,p3) + 4.D0/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 4.
     &    D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 - 8.D0/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p3)*s(p2,p3) )
      c1234 = c1234 + nDn*s124**(-1)*s134**(-1) * (  - 4.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * ( 27.D0/4.D0*s(p1,p2)
     &    **2 + 11.D0/4.D0*s(p1,p2)*s(p1,p3) + 57.D0/4.D0*s(p1,p2)*s(p1
     &    ,p4) - 7.D0/2.D0*s(p1,p2)*s(p2,p3) + 13.D0/4.D0*s(p1,p2)*s(p2
     &    ,p4) - 9.D0*s(p1,p3)**2 + 7.D0/2.D0*s(p1,p3)*s(p1,p4) - 9.D0/
     &    2.D0*s(p1,p3)*s(p2,p3) + 15.D0/4.D0*s(p1,p3)*s(p2,p4) + 41.D0/
     &    4.D0*s(p1,p4)**2 - 5.D0*s(p1,p4)*s(p2,p3) + 5.D0*s(p1,p4)*s(
     &    p2,p4) + 2.D0*s(p2,p4)**2 - 4.D0/(s(p1,p2))*s(p1,p3)**3 - 11.D
     &    0/2.D0/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) - 2.D0/(s(p1,p2))*s(p1
     &    ,p3)**2*s(p2,p3) + 1/(s(p1,p2))*s(p1,p3)**2*s(p2,p4) + 3.D0/4.
     &    D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 - 9.D0/2.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p3) + 9.D0/4.D0/(s(p1,p2))*s(p1,p3)*s(p1
     &    ,p4)*s(p2,p4) + 1/(s(p1,p2))*s(p1,p3)*s(p2,p4)**2 + 9.D0/4.D0
     &    /(s(p1,p2))*s(p1,p4)**3 - 5.D0/2.D0/(s(p1,p2))*s(p1,p4)**2*s(
     &    p2,p3) + 5.D0/4.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p4) + 1/(s(p1,
     &    p2))*s(p1,p4)*s(p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**4 )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * (  - 1/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)**3*s(p1,p4) + 3.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)**3*s(p2,p4) + 1.D0/4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p1,p4)**2 + 13.D0/4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**
     &    2*s(p1,p4)*s(p2,p4) - 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(
     &    p2,p4)**2 - 3.D0/4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)
     &    **3 + 5.D0/4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(
     &    p2,p4) - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    )**2 + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4) - 1/(s(p1
     &    ,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)**2 - 1/(s(p1,p2))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)**2 - 1/(s(p1,p2))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)*s(p2,p4) - 1/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**3 - 1/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*s(p2,p4) - 2.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**4 - 4.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)**3*s(p1,p4) )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)**3*s(p2,p3) - 3.D0/2.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p3)**2*s(p1,p4)**2 - 17.D0/2.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3) - 2.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)**2*s(p2,p3)**2 + 1.D0/2.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p1,p4)**3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)**2*s(p2,p3) - 9.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p3)**2 + 1.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)**3*s(p2,p3) - 5.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2
     &    *s(p2,p3)**2 + 1.D0/2.D0/(s(p1,p4))*s(p1,p2)**3 - 1/(s(p1,p4)
     &    )*s(p1,p2)**2*s(p2,p3) - 1.D0/2.D0/(s(p1,p4))*s(p1,p2)**2*s(
     &    p2,p4) - 5.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2 - 1/(s(p1,
     &    p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 3.D0/2.D0/(s(p1,p4))*s(p1,
     &    p2)*s(p1,p3)*s(p2,p4) + 1/(s(p1,p4))*s(p1,p2)*s(p2,p4)**2 - 2.
     &    D0/(s(p1,p4))*s(p1,p3)**3 - 1/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)
     &     + 1/(
     & s(p1,p4))*s(p1,p3)*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2
     &    )**2*s(p1,p3)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)*s(p2,p4) - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4
     &    )**2 - 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3 + 7.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) - 5.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 + 1/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)**4 + 5.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*s(
     &    p2,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2
     &     + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**3 - 1/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)**2 + 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*s(p2,p4) - 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)**2 - 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**3 + 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*s(
     &    p2,p4) )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * ( 1/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)**2 - 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**3 - 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3*s(p2,p4) + 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,
     &    p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    *s(p2,p4)**3 + 3.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*s(
     &    p1,p3) - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*s(p2,p3) + 3.D0/
     &    2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2 - 9.D0/2.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3) - 1/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)**2 - 2.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)**3 - 11.D0/2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p3) - 1/(s(p1,p4))/(s(p3,p4
     &    ))*s(p1,p2)*s(p1,p3)*s(p2,p3)**2 - 2.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p3)**4 - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3
     &    ) )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * ( 1.D0/4.D0/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p1,p3) - 9.D0/4.D0/(s(p2,p3))*s(p1,p2)**2*s(
     &    p2,p4) - 3.D0/4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 1.D0/4.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4) - 1/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)*s(p2,p4) - 7.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    s(p2,p4) - 9.D0/4.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 - 4.D0/(
     &    s(p2,p3))*s(p1,p3)**3 + 1.D0/2.D0/(s(p2,p3))*s(p1,p3)**2*s(p1
     &    ,p4) + 29.D0/4.D0/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 5.D0/4.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)**2 - 7.D0/4.D0/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)*s(p2,p4) - 25.D0/4.D0/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)**2 - 1.D0/4.D0/(s(p2,p3))*s(p1,p4)**2*s(p2,p4) - 9.D0/4.D0
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)**2 + 1/(s(p2,p3))*s(p2,p4)**3
     &     - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 + 6.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) - 2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 3.D0/(s(p2,p3)
     &    )/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)**3 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)**2*s(p1,p4) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)**2*s(p2,p4) + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*s(p1,p4)*s(p2,p4) + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)*s(p2,p4)**2 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p4)*s(p2,p4)**2 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4
     &    )**3 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4) - 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4) - 4.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2 - 1/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p1,p4)*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p1,p4)**2*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p4)**2 + 6.D0/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)
     &     + 1.D0/2.D0/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) + 5.D0/2.D0/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)**2 + 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p3)*s(p1,p4) )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * (  - 7.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p3) + 9.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p4)*s(p2,p3) - 7.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2
     &     - 6.D0/(s(p3,p4))*s(p1,p3)**3 - 1.D0/2.D0/(s(p3,p4))*s(p1,p3
     &    )**2*s(p1,p4) - 11.D0/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) + 4.D0
     &    /(s(p3,p4))*s(p1,p3)*s(p1,p4)**2 - 13.D0/2.D0/(s(p3,p4))*s(p1
     &    ,p3)*s(p1,p4)*s(p2,p3) - 9.D0/2.D0/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p3)**2 + 7.D0/2.D0/(s(p3,p4))*s(p1,p4)**2*s(p2,p3) - 5.D0/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-1) * ( 7.D0*s(p1,p2) - 21.D0*s(p1,p3)
     &     + 6.D0*s(p1,p4) - 24.D0*s(p2,p3) - s(p2,p4) - 24.D0*s(p3,p4)
     &     - 13.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4) - 4.D0/(s(p1,p2))*s(p1,
     &    p3)*s(p2,p3) - 1/(s(p1,p2))*s(p1,p3)*s(p2,p4) + 3.D0/(s(p1,p2
     &    ))*s(p1,p4)**2 - 16.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3) - 1/(s(p1
     &    ,p2))*s(p1,p4)*s(p2,p4) - 16.D0/(s(p1,p2))*s(p1,p4)*s(p3,p4)
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 + 4.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3) + 8.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*
     &    s(p3,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3 - 7.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4) + 1/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4
     &    )**2 )
      c1234 = c1234 + nDn*s124**(-1) * ( 2.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*s(p3,p4) + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3 + 
     &    1/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4) - 4.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p4)**2*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)**3 + 1.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*
     &    s(p1,p4) - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) + 
     &    5.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2 - 7.D0/2.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) - 4.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 + 5.D0/2.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)*s(p2,p3)**2 + 4.D0/(s(p1,p4))*s(p1,p2)**2 - 12.D
     &    0/(s(p1,p4))*s(p1,p2)*s(p1,p3) - 16.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p2,p3) - 16.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4) - 4.D0/(s(p1,p4))
     &    *s(p1,p3)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*
     &    s(p1,p3) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 4.D0/(s(p1,p4))/(s(p1,p4))*
     &    s(p1,p2)**2*s(p2,p3) - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2
     &    *s(p3,p4) + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2
     &     + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 4.D
     &    0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p3,p4) - 1/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)**3 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2
     &    )**2*s(p1,p3) + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)
     &     - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 + 4.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 7.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,p4) - 1/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p2)*s(p2,p4)**2 + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3
     &    ,p4)**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3 + 4.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 8.D0/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p3)**2*s(p3,p4) - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)**2 )
      c1234 = c1234 + nDn*s124**(-1) * ( 1/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*
     &    s(p3,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **3*s(p1,p3) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3
     &    *s(p2,p4) - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(
     &    p3,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)*s(p2,p4) - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*s(p3,p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p2,p4)*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 1/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*s(p3,p4) + 2.D
     &    0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3 + 3.D0/2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)**2*s(p1,p3) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 3.D0/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p2,p3) - 5.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)**2 - 7.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p3) - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**3 - 4.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) + 1.D0/4.D0/(s(p2,
     &    p3))*s(p1,p2)**2 + 17.D0/4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 
     &    13.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4) + 5.D0/4.D0/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4) + 2.D0/(s(p2,p3))*s(p1,p2)*s(p3,p4) - 11.D
     &    0/(s(p2,p3))*s(p1,p3)**2 + 5.D0/4.D0/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4) + 25.D0/4.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4) - 19.D0/(s(p2,
     &    p3))*s(p1,p3)*s(p3,p4) + 17.D0/4.D0/(s(p2,p3))*s(p1,p4)**2 + 
     &    9.D0/4.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4) - 7.D0/(s(p2,p3))*s(p1
     &    ,p4)*s(p3,p4) - 1/(s(p2,p3))*s(p2,p4)**2 + 1/(s(p2,p3))*s(p2,
     &    p4)*s(p3,p4) - 8.D0/(s(p2,p3))*s(p3,p4)**2 - 6.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3) + 2.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p2,p4) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p3,p4) - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)**2 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1
     &    ,p4) - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)
     &     - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,p4) + 1/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 1/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p3,p4) + 1/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)**2 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)*s(p3,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(
     &    p1,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2 - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) + 17.D0/2.D0/(s(p3,p4
     &    ))*s(p1,p2)*s(p1,p3) + 7.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)
     &     - 3.D0/(s(p3,p4))*s(p1,p3)**2 + 15.D0/2.D0/(s(p3,p4))*s(p1,
     &    p3)*s(p1,p4) - 31.D0/2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3) + 5.D0
     &    /(
     & s(p3,p4))*s(p1,p4)*s(p2,p3) - 8.D0/(s(p3,p4))*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s134**(-2) * (  - 2.D0*s(p1,p2)**2 - 4.D0*s(
     &    p1,p2)*s(p2,p3) - 4.D0*s(p1,p2)*s(p2,p4) - 2.D0*s(p2,p3)**2
     &     - 4.D0*s(p2,p3)*s(p2,p4) - 2.D0*s(p2,p4)**2 - 2.D0/(s(p1,p4)
     &    )/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,
     &    p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p3) - 4.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))
     &    *s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3
     &    )**2*s(p2,p3)*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)
     &    **2*s(p2,p4)**2 - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1
     &    ,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(
     &    p2,p3) - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2
     &    ,p4) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 4.
     &    D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*s(p2,p4) - 2.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 )
      c1234 = c1234 + nDn*s134**(-1)*s234**(-1) * (  - 33.D0/2.D0*s(p1,
     &    p2)**2 - 1.D0/2.D0*s(p1,p2)*s(p1,p3) + 5.D0*s(p1,p2)*s(p1,p4)
     &     - 16.D0*s(p1,p2)*s(p2,p3) - 13.D0*s(p1,p2)*s(p2,p4) + 7.D0*
     &    s(p1,p3)**2 + 14.D0*s(p1,p3)*s(p1,p4) - 11.D0*s(p1,p3)*s(p2,
     &    p4) + 6.D0*s(p1,p4)**2 - s(p1,p4)*s(p2,p3) - 9.D0/2.D0*s(p1,
     &    p4)*s(p2,p4) - 7.D0*s(p2,p3)**2 - 15.D0/2.D0*s(p2,p3)*s(p2,p4
     &    ) - s(p2,p4)**2 + 3.D0/(s(p1,p2))*s(p1,p3)**2*s(p2,p3) - 6.D0
     &    /(s(p1,p2))*s(p1,p3)**2*s(p2,p4) + 6.D0/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p3) - 3.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    ) - 3.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2 + 3.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p4)**2 + 3.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p3) - 3.
     &    D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2 - 3.D0/(s(p1,p2))*s(p1,p4)
     &    *s(p2,p3)*s(p2,p4) - 3.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*
     &    s(p2,p4) + 3.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*s(
     &    p2,p4) + 3.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)**2
     &     - 3.D0/2.D0/(
     & s(p1,p4))*s(p1,p2)**3 - 5.D0/(s(p1,p4))*s(p1,p2)**2*s(p1,p3) - 1.
     &    D0/2.D0/(s(p1,p4))*s(p1,p2)**2*s(p2,p3) - 3.D0/2.D0/(s(p1,p4)
     &    )*s(p1,p2)**2*s(p2,p4) - 9.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,
     &    p3)**2 - 1.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 4.D
     &    0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 1/(s(p1,p4))*s(p1,
     &    p2)*s(p2,p3)**2 + 1.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*s(p2
     &    ,p4) - 1/(s(p1,p4))*s(p1,p3)**3 - 11.D0/2.D0/(s(p1,p4))*s(p1,
     &    p3)**2*s(p2,p4) - 1/(s(p1,p4))*s(p1,p3)*s(p2,p3)**2 + 7.D0/2.D
     &    0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) + 3.D0/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**4
     &     - 7.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) - 11.D
     &    0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) + 1.D0/2.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 - 21.D0/2.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) - 5.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 + 2.D0/(s(p1,p4))
     &    /(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)**3 - 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)**2*s(p2,p4) - 17.D0/2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 3.D0/2.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)**3 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    **3*s(p2,p4) - 7.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(
     &    p2,p4)**2 - 3.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)
     &    **3 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)
     &    **2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)
     &    *s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)**3 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p3)*s(p2,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)**3*s(p2,p4) - 1/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)**2 - 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**3 + 1/(
     &    s(p1,p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)**2 - 1/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**3 + 1.D0/2.D0/(s(p2,
     &    p3))*s(p1,p2)**3 + 17.D0/2.D0/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &     + 4.D0/(s(p2,p3))*s(p1,p2)**2*s(p1,p4) - 4.D0/(s(p2,p3))*s(
     &    p1,p2)**2*s(p2,p4) + 9.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 + 
     &    11.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4) - 3.D0/2.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 4.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4)**2 - 11.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4
     &    ) - 1/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 5.D0/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4) + 2.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)
     &     - 1/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 1/(s(p2,p3))*s(p1,p4)
     &    **2*s(p2,p4) - 1.D0/2.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2 - 1.D
     &    0/2.D0/(s(p2,p3))*s(p2,p4)**3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**3*s(p1,p3) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1
     &    ,p4) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) + 3.D0/(
     &    s(p2,p3))/(
     & s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 + 3.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3)*s(p1,p4) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p4)**2 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1
     &    ,p4)*s(p2,p4) + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    **2*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    s(p1,p4)*s(p2,p4) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    *s(p2,p4)**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**
     &    2 + 8.D0/(s(p3,p4))*s(p1,p2)**3 + 4.D0/(s(p3,p4))*s(p1,p2)**2
     &    *s(p1,p3) - 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 4.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3) )
      c1234 = c1234 + nDn*s134**(-1) * (  - 7.D0*s(p1,p2) + 8.D0*s(p1,
     &    p3) + 4.D0*s(p1,p4) - 9.D0*s(p2,p3) - 23.D0/2.D0*s(p2,p4) + 3.
     &    D0/(s(p1,p2))*s(p1,p3)*s(p2,p3) - 3.D0/(s(p1,p2))*s(p1,p3)*s(
     &    p2,p4) + 7.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3) + 4.D0/(s(p1,p2))*
     &    s(p1,p4)*s(p2,p4) - 8.D0/(s(p1,p2))*s(p2,p3)**2 - 8.D0/(s(p1,
     &    p2))*s(p2,p3)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)
     &    **2*s(p2,p3) - 7.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4
     &    ) + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) + 8.
     &    D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)*s(p2,p3)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 8.D0/(s(p1,p2))/(s(p3,p4)
     &    )/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*s(p2,p4) - 4.D0/(s(p1,p2))
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 + 9.D0/2.D0/(
     &    s(p1,p4))*s(p1,p2)**2 + 19.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,
     &    p3) )
      c1234 = c1234 + nDn*s134**(-1) * (  - 3.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p2,p3) + 5.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4) + 5.D0/(s(p1,
     &    p4))*s(p1,p3)**2 + 1/(s(p1,p4))*s(p1,p3)*s(p2,p3) - 1.D0/2.D0
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4) + 8.D0/(s(p1,p4))*s(p2,p3)*s(p2
     &    ,p4) + 8.D0/(s(p1,p4))*s(p2,p4)**2 + 4.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)**2*s(p1,p3) - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)
     &    *s(p1,p3)**2 + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    s(p2,p3) + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,
     &    p4) - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3) - 4.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4) - 1.D0/2.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)**3 + 7.D0/2.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p1,p3) - 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4) + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**
     &    2 + 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 9.
     &    D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 4.D0/(s(
     &    p1,p4))/(
     & s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**3*s(p1,p3) - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p3)**2 + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p3)*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 1/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 + 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2 + 3.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p3) + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)
     &     - 1.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4) + 3.D0/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4) + 1/(s(p2,p3))*s(p1,p4)*s(p2,p4) - 7.D0/2.D0
     &    /(s(p2,p3))*s(p2,p4)**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3
     &     + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4) + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) )
      c1234 = c1234 + nDn*s134**(-1) * (  - 2.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3 - 3.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)
     &     - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4) + 3.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 4.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2 + 16.D0/(s(p3,p4))*s(p1,p2
     &    )**2 + 4.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3) + 8.D0/(s(p3,p4))*s(
     &    p1,p2)*s(p2,p3) + 8.D0/(s(p3,p4))*s(p1,p2)*s(p2,p4) - 8.D0/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p3) + 8.D0/(s(p3,p4))*s(p2,p3)**2 + 
     &    16.D0/(s(p3,p4))*s(p2,p3)*s(p2,p4) + 8.D0/(s(p3,p4))*s(p2,p4)
     &    **2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 + 8.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 8.D0/(s(
     &    p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 8.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p2,p4) + 4.D0/(s(p3,p4))/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p3)**2 + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2
     &    ,p3)*s(p2,p4) )
      c1234 = c1234 + nDn*s234**(-2) * (  - 4.D0*s(p1,p2)**2 - 8.D0*s(
     &    p1,p2)*s(p1,p3) - 8.D0*s(p1,p2)*s(p1,p4) - 4.D0*s(p1,p3)**2
     &     - 8.D0*s(p1,p3)*s(p1,p4) - 4.D0*s(p1,p4)**2 - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)
     &    **2*s(p2,p4)**2 - 4.D0/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 8.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 8.D0/(s(p3,p4))*s(p1
     &    ,p2)*s(p1,p4)*s(p2,p3) - 4.D0/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)
     &     - 8.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) - 4.D0/(s(p3,p4
     &    ))*s(p1,p4)**2*s(p2,p3) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)
     &    **2*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*
     &    s(p2,p3)**2 )
      c1234 = c1234 + nDn*s234**(-2) * (  - 2.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p3)**2 - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**
     &    2*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s234**(-1) * (  - 157.D0/4.D0*s(p1,p2) - 155.D
     &    0/4.D0*s(p1,p3) - 39.D0*s(p1,p4) - 8.D0*s(p2,p3) - 5.D0/2.D0*
     &    s(p2,p4) - 4.D0/(s(p1,p2))*s(p1,p3)**2 - 37.D0/4.D0/(s(p1,p2)
     &    )*s(p1,p3)*s(p1,p4) - 2.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3) + 6.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p2,p4) - 21.D0/4.D0/(s(p1,p2))*s(p1,p4
     &    )**2 - 2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3) + 3.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p4) + 3.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2
     &    ,p4) - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3 - 17.D0/4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4) + 5.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 13.D0/4.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)*s(p2,p4) - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**
     &    3 - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4) + 1/(s(p1
     &    ,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4) + 1/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2 - 2.D0/(s(p1
     &    ,p2))/(
     & s(p3,p4))*s(p1,p3)**3 - 11.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3
     &    )**2*s(p1,p4) - 9.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,
     &    p3) - 11.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2
     &     - 27.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3
     &    ) - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3 - 9.D0/2.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)**2 - 4.D0/(s(p1
     &    ,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 - 3.D0/(
     &    s(p1,p4))*s(p1,p2)**2 - 7.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3) - 
     &    1/(s(p1,p4))*s(p1,p2)*s(p2,p3) + 1.D0/2.D0/(s(p1,p4))*s(p1,p2
     &    )*s(p2,p4) - 4.D0/(s(p1,p4))*s(p1,p3)**2 - 1/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p3) + 7.D0/2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4) - 7.D0/
     &    2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3 - 19.D0/2.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p1,p3) - 7.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p2,p4) )
      c1234 = c1234 + nDn*s234**(-1) * (  - 9.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)**2 - 7.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*s(p2,p4) - 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)**2 - 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3 - 5.D0/2.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 1/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) - 3.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 + 1/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3 - 4.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)
     &     - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)**2 - 5.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2
     &    *s(p2,p4)**2 - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3 - 11.D0/
     &    2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3) + 3.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 11.D0/2.D0/(s(p1,p4))
     &    /(
     & s(p3,p4))*s(p1,p2)*s(p1,p3)**2 - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2
     &    )*s(p1,p3)*s(p2,p3) - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**3
     &     - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 1/(s(p2,
     &    p3))*s(p1,p2)**2 + 3.D0/4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 8.
     &    D0/(s(p2,p3))*s(p1,p2)*s(p1,p4) - 9.D0/4.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4) - 9.D0/4.D0/(s(p2,p3))*s(p1,p3)**2 + 21.D0/2.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4) + 49.D0/4.D0/(s(p2,p3))*s(p1,p3
     &    )*s(p2,p4) + 14.D0/(s(p2,p3))*s(p1,p4)**2 + 25.D0/4.D0/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4) - 3.D0/2.D0/(s(p2,p3))*s(p2,p4)**2 - 
     &    1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p4) + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4
     &    ) + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 7.D0/(s(p2,p3))
     &    /(
     & s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)**3 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4) - 2.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)*s(p2,p4)**2 + 14.D0/(s(p3,p4))*s(p1,p2)**2 + 27.D0/2.
     &    D0/(s(p3,p4))*s(p1,p2)*s(p1,p3) + 11.D0/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p4) - 13.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3) + 1/(s(p3,
     &    p4))*s(p1,p3)**2 + 15.D0/2.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4) - 
     &    53.D0/2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3) + 6.D0/(s(p3,p4))*s(
     &    p1,p4)**2 - 16.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3) + 8.D0/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 4.D0/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p2)*s(p2,p3)**2 + 4.D0/(s(p3,p4))/(s(p3,p4))
     &    *s(p1,p3)**2*s(p2,p3) + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p3) - 8.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p3)**2 )
      c1234 = c1234 + nDn*s234**(-1) * (  - 8.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p4)*s(p2,p3)**2 )
      c1234 = c1234 + nDn * (  - 46.D0 - 16.D0/(s(p1,p2))*s(p1,p3) - 20.
     &    D0/(s(p1,p2))*s(p1,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)
     &    **2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4) - 2.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 + 4.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)
     &    *s(p2,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p4)**2*s(p2,p3)**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)
     &    **2 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3 - 12.D
     &    0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 4.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p3,p4) - 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4)
     &     - 2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **4 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p3)**3*s(p2,p4) )
      c1234 = c1234 + nDn * (  - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p3)**3 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p2,p3) - 12.D0/(s(p1,p2))/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p2,p4) - 8.D0/(s(p1,p2))/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) - 8.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2 - 17.D0/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p3)**2 - 22.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4) - 24.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4) - 8.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4) - 9.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2 - 12.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(
     &    p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4) - 8.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2 - 8.D0/(s(p1,p2))/(s(p2,p3
     &    ))*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)**3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p1,p4) )
      c1234 = c1234 + nDn * (  - 12.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p3)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p3)*s(p1,p4)**2 - 12.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p4)**3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p4)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p4)*s(p2,p4)**2 - 5.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2
     &     - 3.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4) - 16.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4) - 2.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p4)**2 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)
     &     - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4) + 8.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p2,p3)**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2
     &    ,p3)*s(p2,p4) + 4.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3
     &    )**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3
     &    )**2*s(p2,p4) )
      c1234 = c1234 + nDn * ( 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p3) + 4.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)**2 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)**2 - 20.D0/(s(p1,p4))*s(p1,p2)
     &     - 16.D0/(s(p1,p4))*s(p1,p3) - 2.D0/(s(p1,p4))/(s(p1,p4))*s(
     &    p1,p2)**2 + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3) - 2.D
     &    0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)**2 - 2.D0/(s(p1,p4))/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)**2 + 4.D0/(s(
     &    p1,p4))/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)**2*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**2 - 9.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3) - 5.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4) + 3.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p3,p4) - 12.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)**2 )
      c1234 = c1234 + nDn * (  - 15.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4) - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4) + 4.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)**2 + 12.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p2,p4)*s(p3,p4) + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**2
     &     + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) - 
     &    5.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4) + 
     &    2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 + 
     &    7.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,
     &    p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p3,p4) + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    **3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,
     &    p3) )
      c1234 = c1234 + nDn * (  - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p2,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3)**2 - 12.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*s(p2,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p4)**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)**3 - 12.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p4) - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)**2 - 12.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**
     &    2 - 20.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3) - 4.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3) - 12.D0/(s(p1,p4))/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p4) - 12.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3
     &    )**2 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3) - 24.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4) - 8.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p2,p3)*s(p2,p4) - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,
     &    p4)**2 + 11.D0/4.D0/(s(p2,p3))*s(p1,p2) - 93.D0/4.D0/(s(p2,p3
     &    ))*s(p1,p3) )
      c1234 = c1234 + nDn * ( 19.D0/4.D0/(s(p2,p3))*s(p1,p4) + 1/(s(p2,
     &    p3))*s(p2,p4) + 7.D0/(s(p2,p3))*s(p3,p4) - 2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3) + 15.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4) + 
     &    1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4) + 2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2 - 7.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)**2 - 14.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3) - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p4) - 23.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4) - 10.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p3)**2 - 14.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4) - 28.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p4) - 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2 - 20.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4) - 12.D0/(s(p2,p3))/(s(p3
     &    ,p4))*s(p2,p4)**2 + 7.D0/(s(p3,p4))*s(p1,p2) - 2.D0/(s(p3,p4)
     &    )*s(p1,p3) )
      c1234 = c1234 + nDn * ( 3.D0/(s(p3,p4))*s(p1,p4) + 8.D0/(s(p3,p4)
     &    )*s(p2,p3) - 8.D0/(s(p3,p4))*s(p2,p4) - 2.D0/(s(p3,p4))/(s(p3
     &    ,p4))*s(p1,p3)**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2
     &    ,p3) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p2,p3)**2 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * ( 8.D0*s(p1,p2)*nDp2*nDp3
     &     + 8.D0*s(p1,p2)*nDp2*nDp4 + 16.D0*s(p1,p2)*nDp3*nDp4 - 16.D0
     &    *s(p3,p4)*nDp2*nDp3 - 16.D0*s(p3,p4)*nDp2*nDp4 + 8.D0*s(p3,p4
     &    )*nDp2**2 - 32.D0*s(p3,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2))*s(p3,
     &    p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))*s(p3,p4)**2*nDp2*nDp4 - 16.
     &    D0/(s(p1,p2))*s(p3,p4)**2*nDp2**2 + 16.D0/(s(p1,p2))*s(p3,p4)
     &    **2*nDp3*nDp4 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p3,p4)**3*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)**2*
     &    nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)**2*
     &    nDp4**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)**3*nDp2*nDp4 + 
     &    8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2*nDp2*nDp3 + 8.
     &    D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2*nDp3**2 + 8.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p3,p4)**3*nDp2*nDp3 + 8.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p3,p4)**3*nDp2**2 + 8.D0/(s(p1,p4))*s(p1,p2)**
     &    2*nDp2*nDp4 + 8.D0/(s(p1,p4))*s(p1,p2)**2*nDp3*nDp4 - 8.D0/(
     &    s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * (  - 8.D0/(s(p1,p4))*s(p1
     &    ,p2)*s(p1,p3)*nDp4**2 - 24.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4)*
     &    nDp2*nDp4 - 16.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4)*nDp3*nDp4 + 16.
     &    D0/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp2*nDp4 + 16.D0/(s(p1,p4))*
     &    s(p1,p3)*s(p3,p4)*nDp4**2 + 24.D0/(s(p1,p4))*s(p3,p4)**2*nDp2
     &    *nDp4 + 8.D0/(s(p1,p4))*s(p3,p4)**2*nDp3*nDp4 + 8.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p2)**3*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)**3*nDp3*nDp4 - 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)**2*s(p3,p4)*nDp2*nDp4 - 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)**2*s(p3,p4)*nDp3*nDp4 + 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)*s(p3,p4)**2*nDp2*nDp4 + 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)*s(p3,p4)**2*nDp3*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p3,
     &    p4)**3*nDp2*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**3*
     &    nDp3*nDp4 + 8.D0/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 + 8.D0/(s(
     &    p2,p3))*s(p1,p2)**2*nDp2*nDp4 + 8.D0/(s(p2,p3))*s(p1,p2)**2*
     &    nDp3*nDp4 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * ( 8.D0/(s(p2,p3))*s(p1,p2
     &    )**2*nDp3**2 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 
     &    8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3**2 - 8.D0/(s(p2,p3))*
     &    s(p1,p2)*s(p3,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))*s(p1,p2)*s(p3,
     &    p4)*nDp2*nDp4 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2**2 - 
     &    16.D0/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp3*nDp4 - 16.D0/(s(p2,p3
     &    ))*s(p1,p2)*s(p3,p4)*nDp3**2 - 16.D0/(s(p2,p3))*s(p1,p4)*s(p3
     &    ,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp3**2
     &     - 8.D0/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp3 + 8.D0/(s(p2,p3))*s(
     &    p3,p4)**2*nDp2*nDp4 - 16.D0/(s(p2,p3))*s(p3,p4)**2*nDp2**2 + 
     &    8.D0/(s(p2,p3))*s(p3,p4)**2*nDp3*nDp4 + 8.D0/(s(p2,p3))*s(p3,
     &    p4)**2*nDp3**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 6.D0*s(p1,p2)*nDp2*
     &    nDp3 + 6.D0*s(p1,p2)*nDp2*nDp4 - 10.D0*s(p1,p2)*nDp2**2 + 4.D0
     &    *s(p1,p2)*nDp3*nDp4 - 2.D0*s(p1,p2)*nDp3**2 + 8.D0*s(p1,p2)*
     &    nDp4**2 - 6.D0*s(p1,p3)*nDp2*nDp3 - 8.D0*s(p1,p3)*nDp2**2 - 6.
     &    D0*s(p1,p4)*nDp2*nDp3 - 8.D0*s(p1,p4)*nDp2*nDp4 - 12.D0*s(p1,
     &    p4)*nDp2**2 - 16.D0*s(p2,p4)*nDp2*nDp3 - 16.D0*s(p2,p4)*nDp2*
     &    nDp4 - 8.D0*s(p2,p4)*nDp2**2 - 8.D0*s(p2,p4)*nDp3*nDp4 - 6.D0
     &    *s(p2,p4)*nDp3**2 + 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 + 8.
     &    D0/(s(p1,p2))*s(p1,p3)**2*nDp2**2 - 16.D0/(s(p1,p2))*s(p1,p3)
     &    *s(p2,p4)*nDp2*nDp3 - 16.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 8.D0/(s(p1,p2))*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,
     &    p2))*s(p2,p4)**2*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3
     &    )**2*s(p2,p4)*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3
     &    )*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)
     &    **3*nDp2*nDp4 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*nDp2*
     &    nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)**3*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)**2*s(p2,p4)*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)**2*s(p2,p4)*nDp2*nDp4 + 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)*s(p2,p4)**2*nDp2*nDp3 + 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,
     &    p4)**3*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**3*
     &    nDp2*nDp4 + 4.D0/(s(p1,p4))*s(p1,p2)**2*nDp2*nDp4 + 4.D0/(s(
     &    p1,p4))*s(p1,p2)**2*nDp3*nDp4 + 8.D0/(s(p1,p4))*s(p1,p2)**2*
     &    nDp4**2 + 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 12.D0
     &    /(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 + 8.D0/(s(p1,p4))*s(
     &    p1,p2)*s(p1,p3)*nDp2**2 + 4.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp3*nDp4 - 16.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 - 20.
     &    D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 - 12.D0/(s(p1,p4))*
     &    s(p1,p2)*s(p2,p4)*nDp2**2 - 12.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4
     &    )*nDp3*nDp4 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 4.D0/(s(p1,p4))*s(p1
     &    ,p2)*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*
     &    nDp4**2 - 8.D0/(s(p1,p4))*s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,
     &    p4))*s(p1,p3)**2*nDp4**2 + 20.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)
     &    *nDp2*nDp4 + 4.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 16.
     &    D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p4))*s(
     &    p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p4))*s(p2,p4)**2*nDp3*nDp4
     &     + 8.D0/(s(p1,p4))*s(p2,p4)**2*nDp4**2 + 4.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)**3*nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)**3*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*
     &    nDp4**2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp2*nDp3 + 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp2*nDp4 + 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp2**2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp3**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 12.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 24.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 - 28.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 - 16.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)**2*s(p2,p4)*nDp2**2 - 20.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp3**2 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)**2*nDp3*nDp4 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 12.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p4)
     &    )/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 - 16.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp3*nDp4 + 8.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 + 8.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 - 8.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p2,p4)**3*nDp2*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p2,p4)**3*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)**3*s(p1,p3)*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*nDp2*nDp4 + 4.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*nDp2**2 + 8.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*nDp3*
     &    nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1
     &    ,p3)*nDp3**2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **3*s(p1,p3)*nDp4**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)*nDp2*nDp4
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)
     &    *nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**3*s(p2,p4)*nDp3**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)**3*s(p2,p4)*nDp4**2 + 8.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp2*nDp3 + 8.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp2*nDp4
     &     + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &    **2*nDp2**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)**2*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)**2*nDp3**2 + 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp4**2 - 8.D0/(s(p1,
     &    p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 8.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p3)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 4.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)
     &    *nDp3**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)*s(p2,p4)*nDp4**2 - 8.D0/(s(p2,p3))*s(p1,p2)**2*nDp2*
     &    nDp3 + 12.D0/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 - 12.D0/(s(p2,
     &    p3))*s(p1,p2)**2*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p2)**2*nDp3*
     &    nDp4 - 2.D0/(s(p2,p3))*s(p1,p2)**2*nDp3**2 + 12.D0/(s(p2,p3))
     &    *s(p1,p2)**2*nDp4**2 - 18.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 24.D
     &    0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 4.D0/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)*nDp3*nDp4 - 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp3**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 8.D0/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)*nDp4**2 - 10.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*
     &    nDp3 - 12.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*nDp4 - 18.D0/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2 - 22.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*
     &    nDp2*nDp4 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 - 12.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 10.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))*s(p1,p3)**2*nDp2*
     &    nDp3 - 6.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 12.D0/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)*nDp2**2 - 32.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 - 16.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 24.
     &    D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 8.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp3*nDp4 - 6.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)
     &    *nDp3**2 + 8.D0/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p2
     &    ,p3))*s(p2,p4)**2*nDp2**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**3*nDp2*nDp3 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**3*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3*nDp4 + 
     &    4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp4**2 - 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp4 - 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2**2 + 4.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 4.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 4.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp4 - 6.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2**2 - 6.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 6.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 - 6.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 6.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2**2 - 6.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*nDp4
     &     - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**4*
     &    nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**4
     &    *nDp3*nDp4 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**
     &    3*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3*s(p1,p3)*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)**3*s(p1,p3)*nDp3*nDp4 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)**3*s(p1,p3)*nDp3**2 - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*s(p2,p4)*nDp3*nDp4 + 2.D0
     &    /(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2
     &    *s(p1,p3)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 2.D0/(s(p2,p3))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp3**2 + 2.D
     &    0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,
     &    p4)*nDp3**2 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp2*
     &    nDp4 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp4**2 + 2.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 2.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2**2 - 2.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 - 2.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 + 4.D0/(s(
     &    p2,p3))/(
     & s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 2.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 - 6.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 - 6.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 2.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p4)*nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 - 4.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3)**2*nDp3*nDp4 - 4.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 6.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2 + 2.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3**2 - 6.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 - 8.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p2,
     &    p3))/(
     & s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 - 6.D0/(s(p2,p3))/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p3)**3*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3
     &    )**3*nDp2**2 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4
     &    )*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)
     &    *nDp2*nDp4 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*
     &    nDp3*nDp4 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*
     &    nDp3**2 + 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*
     &    nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*
     &    nDp2*nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*
     &    nDp3*nDp4 + 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*
     &    nDp3**2 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*nDp2*nDp3 - 
     &    8.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*nDp2*nDp4 - 8.D0/(s(p2
     &    ,p3))/(s(p3,p4))*s(p2,p4)**3*nDp3*nDp4 - 8.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)**3*nDp3**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 4.D0/(s(p3,p4))*s(p1
     &    ,p2)**2*nDp2*nDp4 + 2.D0/(s(p3,p4))*s(p1,p2)**2*nDp3*nDp4 + 4.
     &    D0/(s(p3,p4))*s(p1,p2)**2*nDp4**2 + 4.D0/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp2*nDp4 - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp2**2 - 4.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 - 4.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 - 2.D0/(s(p3,p4))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp3 - 6.D0/(s(p3,p4))*s(p1,p2)*s(p2,p4)*
     &    nDp2*nDp4 - 4.D0/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 2.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 - 2.D0/(s(p3,p4))*s(p1,
     &    p3)**2*nDp2*nDp3 + 2.D0/(s(p3,p4))*s(p1,p3)**2*nDp2**2 + 8.D0
     &    /(s(p3,p4))*s(p1,p3)**2*nDp3*nDp4 + 8.D0/(s(p3,p4))*s(p1,p3)
     &    **2*nDp4**2 + 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 6.
     &    D0/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 - 12.D0/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp3*nDp4 + 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4)
     &    *nDp3**2 - 16.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp4**2 - 6.D0
     &    /(
     & s(p3,p4))*s(p2,p4)**2*nDp2*nDp3 - 8.D0/(s(p3,p4))*s(p2,p4)**2*
     &    nDp2*nDp4 - 6.D0/(s(p3,p4))*s(p2,p4)**2*nDp3**2 + 8.D0/(s(p3,
     &    p4))*s(p2,p4)**2*nDp4**2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * (  - 4.D0*s(p1,p2)*nDp2*
     &    nDp3 - 8.D0*s(p1,p2)*nDp2*nDp4 - 10.D0*s(p1,p2)*nDp2**2 - 12.D
     &    0*s(p1,p2)*nDp3*nDp4 + 2.D0*s(p1,p2)*nDp3**2 - 26.D0*s(p1,p2)
     &    *nDp4**2 - 8.D0*s(p1,p3)*nDp2*nDp3 + 12.D0*s(p1,p3)*nDp2*nDp4
     &     - 8.D0*s(p1,p3)*nDp2**2 - 8.D0*s(p1,p3)*nDp3*nDp4 + 2.D0*s(
     &    p1,p3)*nDp3**2 + 16.D0*s(p1,p4)*nDp2*nDp3 + 28.D0*s(p1,p4)*
     &    nDp2*nDp4 + 28.D0*s(p1,p4)*nDp2**2 - 12.D0*s(p1,p4)*nDp3*nDp4
     &     + 4.D0*s(p1,p4)*nDp3**2 - 12.D0*s(p2,p3)*nDp2*nDp3 - 4.D0*s(
     &    p2,p3)*nDp2*nDp4 - 22.D0*s(p2,p3)*nDp2**2 - 4.D0*s(p2,p3)*
     &    nDp3*nDp4 + 2.D0*s(p2,p3)*nDp3**2 - 10.D0*s(p2,p3)*nDp4**2 + 
     &    16.D0*s(p2,p4)*nDp2*nDp4 - 8.D0*s(p2,p4)*nDp2**2 + 12.D0*s(p2
     &    ,p4)*nDp3*nDp4 - 8.D0*s(p2,p4)*nDp4**2 - 4.D0/(s(p1,p2))*s(p1
     &    ,p3)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp4 + 4.
     &    D0/(s(p1,p2))*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p3)
     &    **2*nDp3*nDp4 + 2.D0/(s(p1,p2))*s(p1,p3)**2*nDp4**2 + 4.D0/(
     &    s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 4.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p1,p4)*nDp2*nDp4 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 4.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp3**2 - 12.D0/(s(p1,p2))*s(p1
     &    ,p3)*s(p2,p3)*nDp2*nDp3 - 6.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp3*nDp4 + 2.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp4**2 - 4.D0/(s(p1,p2))*s(p1,
     &    p3)*s(p2,p4)*nDp2*nDp4 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 8.D0
     &    /(s(p1,p2))*s(p1,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))*s(p1,p4)
     &    **2*nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 
     &    12.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 + 16.D0/(s(p1,p2
     &    ))*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,
     &    p3)*nDp3*nDp4 + 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp3**2 + 
     &    12.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2)
     &    )*s(p1,p4)*s(p2,p4)*nDp2*nDp4 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 20.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p2))*s(p2,p3)**2*nDp2*nDp3
     &     - 4.D0/(s(p1,p2))*s(p2,p3)**2*nDp2*nDp4 - 12.D0/(s(p1,p2))*
     &    s(p2,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp2*
     &    nDp4 - 8.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp2**2 + 4.D0/(s(p1
     &    ,p2))*s(p2,p3)*s(p2,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2))*s(p2,p4)
     &    **2*nDp2*nDp4 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**3*nDp2*
     &    nDp4 + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**3*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 - 6.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 + 6.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3)*nDp2**2 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 2.D0/(
     &    s(p1,p2))/(
     & s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2*nDp2**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2*nDp4 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2*nDp2**2 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp2**2 - 2.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4)*
     &    nDp2**2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*
     &    s(p2,p3)*nDp2**2 - 6.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)**2*s(p1,p4)**2*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3)*nDp2**2 + 2.D0/(s(p1,p2
     &    ))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2*nDp2**2 - 4.D
     &    0/(
     & s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3*nDp2**2 - 2.
     &    D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2
     &    ,p3)*nDp2**2 + 6.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p3)**2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p4)**3*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*nDp2**2 + 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 4.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)**3*nDp2*nDp4 + 12.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4)**2*nDp2*nDp4 - 10.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4)**2*nDp2**2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * (  - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp4 + 2.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp4 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*nDp2**2 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp4 - 8.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2*nDp4 - 2.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2**2 - 8.D0/(s(p2,p3))*s(
     &    p1,p2)**2*nDp2*nDp4 - 8.D0/(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4
     &     - 16.D0/(s(p2,p3))*s(p1,p2)**2*nDp4**2 + 24.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4
     &    )*nDp2*nDp4 + 24.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2 - 16.
     &    D0/(
     & s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3*nDp4 + 8.D0/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*
     &    nDp4 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp4**2 + 16.D0/(s(
     &    p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 40.D0/(s(p2,p3))*s(p1,p4)*s(
     &    p2,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*
     &    nDp4 + 32.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 - 8.D0/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)*nDp3*nDp4 + 8.D0/(s(p2,p3))*s(p1,p4
     &    )*s(p2,p4)*nDp3**2 + 8.D0/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp4 + 
     &    8.D0/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4 + 16.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2**2 + 8.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p4)*nDp3**2 + 32.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2**2 + 16.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp3**2 + 16.D0/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 8.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p4)*s(p2,p4)**2*nDp3**2 + 8.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3*nDp2*nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**
     &    3*nDp3*nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp4**2
     &     + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3
     &     - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp4
     &     + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp3*nDp4
     &     + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp3**2 - 
     &    8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)**2*nDp2*nDp3 + 6.
     &    D0/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp4 + 4.D0/(s(p3,p4))*s(p1,p2
     &    )**2*nDp3*nDp4 + 4.D0/(s(p3,p4))*s(p1,p2)**2*nDp4**2 - 6.D0/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 8.D0/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)*nDp3*nDp4 - 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp4**2 + 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 - 4.D0
     &    /(
     & s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3*nDp4 + 2.D0/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p4)*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp4**2
     &     - 2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp2*nDp4 + 2.D0/(s(p3,
     &    p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p3)*nDp4**2 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp4 - 4.D0
     &    /(s(p3,p4))*s(p1,p3)**2*nDp3*nDp4 - 4.D0/(s(p3,p4))*s(p1,p3)
     &    **2*nDp4**2 + 20.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 
     &    2.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 - 4.D0/(s(p3,p4))*
     &    s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 2.D0/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp4**2 - 4.D0
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 2.D0/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p3)*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp4**2 + 8.D0/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp4 - 4.D0/(s(p3,
     &    p4))*s(p1,p4)**2*nDp2**2 - 8.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*
     &    nDp2*nDp3 + 4.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 - 2.D0
     &    /(
     & s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.D0/(s(p3,p4))*s(p1,p4)*
     &    s(p2,p3)*nDp3*nDp4 + 2.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*
     &    nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp4**2 + 4.D0/(
     &    s(p3,p4))*s(p2,p3)**2*nDp3*nDp4 + 2.D0/(s(p3,p4))*s(p2,p3)**2
     &    *nDp3**2 )
      c1234 = c1234 + s123**(-1) * ( 12.D0*nDp2*nDp3 + 20.D0*nDp2*nDp4
     &     + 46.D0*nDp2**2 - 8.D0*nDp3*nDp4 + 16.D0*nDp4**2 + 8.D0/(s(
     &    p1,p2))*s(p1,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*nDp2*
     &    nDp4 - 8.D0/(s(p1,p2))*s(p1,p3)*nDp2**2 - 8.D0/(s(p1,p2))*s(
     &    p1,p3)*nDp4**2 + 8.D0/(s(p1,p2))*s(p1,p4)*nDp2*nDp3 - 24.D0/(
     &    s(p1,p2))*s(p1,p4)*nDp2*nDp4 - 4.D0/(s(p1,p2))*s(p1,p4)*
     &    nDp2**2 + 16.D0/(s(p1,p2))*s(p1,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2
     &    ))*s(p2,p3)*nDp2*nDp3 + 4.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp4 + 
     &    12.D0/(s(p1,p2))*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))*s(p2,p4)*
     &    nDp2*nDp3 - 40.D0/(s(p1,p2))*s(p2,p4)*nDp2*nDp4 + 16.D0/(s(p1
     &    ,p2))*s(p2,p4)*nDp2**2 + 16.D0/(s(p1,p2))*s(p2,p4)*nDp3*nDp4
     &     + 16.D0/(s(p1,p2))*s(p3,p4)*nDp2*nDp3 - 24.D0/(s(p1,p2))*s(
     &    p3,p4)*nDp2*nDp4 - 8.D0/(s(p1,p2))*s(p3,p4)*nDp2**2 + 32.D0/(
     &    s(p1,p2))*s(p3,p4)*nDp3*nDp4 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)**2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,
     &    p4)*nDp2**2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p3)*s(p2,p3)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)
     &    **2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*
     &    nDp2**2 + 32.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 + 24.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p3,p4)*
     &    nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)**2*nDp2**2 + 
     &    24.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)*s(p3,p4)*nDp2**2 + 16.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p3,p4)**2*nDp2**2 - 2.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*nDp2**2 - 6.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2**2 - 2.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2
     &    *nDp2**2 - 6.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p4)**3*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)**2*s(p2,p3)*nDp2**2 )
      c1234 = c1234 + s123**(-1) * ( 24.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 24.D0/(s(p1,p2))/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 8.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p2,p4)**3*nDp2**2 - 8.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4)
     &    )*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)*s(p3,p4)*nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)*s(p3,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**
     &    2*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)*s(p3,p4)*
     &    nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)**2*nDp2*nDp4
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 8.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp3**2 + 24.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p4)*s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s123**(-1) * ( 24.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)*s(p3,p4)*nDp2*nDp3 + 24.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)
     &    *s(p3,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3
     &    ,p4)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp2*
     &    nDp3 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp2**2 + 24.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2*nDp3 + 24.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2**2 + 16.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p3,p4)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 16.D0/(s(p1
     &    ,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 
     &    16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*
     &    nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*
     &    nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3
     &    *nDp2**2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*
     &    nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp2**2 + 
     &    16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 12.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 4.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 + 4.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 4.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 + 24.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 24.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**2*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p4)**2*nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp4
     &     + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2**2 - 24.D
     &    0/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 40.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 24.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp3 - 32.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p4))*s(p1,p2)*nDp2*
     &    nDp3 - 28.D0/(s(p1,p4))*s(p1,p2)*nDp2*nDp4 - 8.D0/(s(p1,p4))*
     &    s(p1,p2)*nDp2**2 - 20.D0/(s(p1,p4))*s(p1,p2)*nDp3*nDp4 - 16.D0
     &    /(s(p1,p4))*s(p1,p2)*nDp4**2 + 24.D0/(s(p1,p4))*s(p1,p3)*nDp2
     &    *nDp4 + 8.D0/(s(p1,p4))*s(p1,p3)*nDp4**2 + 16.D0/(s(p1,p4))*
     &    s(p2,p4)*nDp2*nDp3 + 12.D0/(s(p1,p4))*s(p2,p4)*nDp2*nDp4 + 16.
     &    D0/(s(p1,p4))*s(p2,p4)*nDp2**2 + 12.D0/(s(p1,p4))*s(p2,p4)*
     &    nDp3*nDp4 + 16.D0/(s(p1,p4))*s(p2,p4)*nDp4**2 + 24.D0/(s(p1,
     &    p4))*s(p3,p4)*nDp2*nDp4 + 8.D0/(s(p1,p4))*s(p3,p4)*nDp2**2 + 
     &    16.D0/(s(p1,p4))*s(p3,p4)*nDp3*nDp4 + 16.D0/(s(p1,p4))*s(p3,
     &    p4)*nDp4**2 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp2*
     &    nDp3 - 36.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 - 12.
     &    D0/(
     & s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp2**2 - 28.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)**2*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)**2*nDp3**2 - 20.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp4**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4
     &     - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 4.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 32.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 28.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 + 24.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 + 12.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)*nDp3**2 + 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4)*nDp2*nDp3 + 40.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*s(p3,p4)*nDp2*nDp4 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *s(p3,p4)*nDp2**2 )
      c1234 = c1234 + s123**(-1) * ( 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*s(p3,p4)*nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *s(p3,p4)*nDp4**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)*nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp3*nDp4 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp4
     &     - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4 - 24.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2*nDp4 - 24.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp3*nDp4 - 16.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp4 - 16.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p3,p4)**2*nDp3*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**3*nDp2*nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**3*nDp2*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**3*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*nDp3**2 - 4.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(
     & s(p2,p3))*s(p1,p2)**3*nDp4**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 8.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp4 - 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2**2 - 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3*
     &    nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1
     &    ,p3)*nDp3**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 + 16.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2**2 + 16.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp3*
     &    nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4)*nDp3**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p3,p4)*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1) * ( 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p3,p4)*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)*nDp2**2 + 16.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)*nDp3*nDp4 + 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)*
     &    nDp3**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p3,p4)*nDp4**2 + 42.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp3 + 36.D0
     &    /(s(p2,p3))*s(p1,p2)*nDp2*nDp4 + 56.D0/(s(p2,p3))*s(p1,p2)*
     &    nDp2**2 - 16.D0/(s(p2,p3))*s(p1,p2)*nDp3*nDp4 - 8.D0/(s(p2,p3
     &    ))*s(p1,p2)*nDp3**2 - 4.D0/(s(p2,p3))*s(p1,p3)*nDp2*nDp3 + 2.D
     &    0/(s(p2,p3))*s(p1,p3)*nDp2**2 + 16.D0/(s(p2,p3))*s(p1,p4)*
     &    nDp2*nDp3 + 8.D0/(s(p2,p3))*s(p1,p4)*nDp2*nDp4 - 16.D0/(s(p2,
     &    p3))*s(p1,p4)*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p4)*nDp3*nDp4 + 
     &    40.D0/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p2,p3))*s(p2,p4
     &    )*nDp2*nDp4 + 16.D0/(s(p2,p3))*s(p2,p4)*nDp2**2 - 8.D0/(s(p2,
     &    p3))*s(p2,p4)*nDp3*nDp4 )
      c1234 = c1234 + s123**(-1) * ( 8.D0/(s(p2,p3))*s(p2,p4)*nDp3**2
     &     + 8.D0/(s(p2,p3))*s(p3,p4)*nDp2*nDp3 - 24.D0/(s(p2,p3))*s(p3
     &    ,p4)*nDp2*nDp4 - 24.D0/(s(p2,p3))*s(p3,p4)*nDp2**2 + 8.D0/(s(
     &    p2,p3))*s(p3,p4)*nDp3*nDp4 + 16.D0/(s(p2,p3))*s(p3,p4)*
     &    nDp3**2 + 38.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3
     &     + 20.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 + 22.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2**2 + 16.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4 + 16.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)**2*nDp3**2 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1
     &    ,p3)*nDp2*nDp4 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    *nDp2**2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2
     &    *nDp3 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2
     &     + 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 
     &    16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 + 16.D
     &    0/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3**2 - 16.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2*nDp4 - 16.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p3,p4)*nDp2**2 - 16.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)*s(p2,p4)*nDp2**2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p4)*s(p3,p4)*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)**3*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp3**2 - 2.D0/(s(p2,
     &    p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3**2
     &     - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 - 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp4 + 2.D0/(s(p2,p3))
     &    /(
     & s(p3,p4))*s(p1,p2)**2*nDp2**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p2)**2*nDp3*nDp4 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp3 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp4
     &     + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 4.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 - 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 2.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 + 6.D0/(s(p2,p3))/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p2)*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**
     &    2*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp2**2
     &     - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 2.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 + 8.D0/(s(
     &    p2,p3))/(
     & s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 + 6.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p4)*nDp3*nDp4 + 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*
     &    s(p2,p4)*nDp3**2 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,
     &    p4)*nDp2*nDp3 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp4 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp3
     &    *nDp4 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp3**2
     &     - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp3 - 16.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp4 - 16.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p2,p4)**2*nDp3*nDp4 - 16.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p2,p4)**2*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp4
     &     + 2.D0/(s(p3,p4))*s(p1,p2)*nDp2**2 + 2.D0/(s(p3,p4))*s(p1,p2
     &    )*nDp3**2 + 6.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 4.D0/(s(p3,
     &    p4))*s(p1,p3)*nDp2*nDp4 - 2.D0/(s(p3,p4))*s(p1,p3)*nDp2**2 - 
     &    12.D0/(
     & s(p3,p4))*s(p1,p3)*nDp3*nDp4 - 2.D0/(s(p3,p4))*s(p1,p3)*nDp3**2
     &     - 8.D0/(s(p3,p4))*s(p1,p3)*nDp4**2 + 6.D0/(s(p3,p4))*s(p1,p4
     &    )*nDp2*nDp3 + 4.D0/(s(p3,p4))*s(p1,p4)*nDp2*nDp4 + 4.D0/(s(p3
     &    ,p4))*s(p1,p4)*nDp2**2 + 8.D0/(s(p3,p4))*s(p1,p4)*nDp3*nDp4
     &     + 8.D0/(s(p3,p4))*s(p1,p4)*nDp4**2 - 4.D0/(s(p3,p4))*s(p2,p3
     &    )*nDp3*nDp4 - 2.D0/(s(p3,p4))*s(p2,p3)*nDp3**2 - 4.D0/(s(p3,
     &    p4))*s(p2,p4)*nDp2*nDp4 + 6.D0/(s(p3,p4))*s(p2,p4)*nDp2**2 + 
     &    12.D0/(s(p3,p4))*s(p2,p4)*nDp3*nDp4 - 2.D0/(s(p3,p4))*s(p2,p4
     &    )*nDp3**2 + 16.D0/(s(p3,p4))*s(p2,p4)*nDp4**2 )
      c1234 = c1234 + s124**(-1)*s134**(-1) * (  - 8.D0*s(p1,p2)*nDp3*
     &    nDp4 - 8.D0*s(p1,p2)*nDp3**2 + 8.D0*s(p1,p3)*nDp2*nDp3 + 8.D0
     &    *s(p1,p3)*nDp2*nDp4 + 8.D0*s(p1,p3)*nDp3*nDp4 + 8.D0*s(p1,p3)
     &    *nDp3**2 + 8.D0*s(p1,p4)*nDp2*nDp3 - 8.D0*s(p1,p4)*nDp3**2 - 
     &    16.D0*s(p2,p3)*nDp2*nDp3 - 8.D0*s(p2,p3)*nDp3*nDp4 + 16.D0*s(
     &    p2,p3)*nDp3**2 - 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 - 8.D0
     &    /(s(p1,p2))*s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 - 24.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 8.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 + 16.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*
     &    nDp2*nDp3 - 16.D0/(s(p1,p2))*s(p2,p3)**2*nDp2*nDp3 - 8.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp4 - 8.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p2,p3)**3*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p3)**3*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s134**(-1) * (  - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**3*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p3)**2*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p3)**2*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p2,p3)**3*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**
     &    3*nDp2*nDp4 + 16.D0/(s(p1,p4))*s(p2,p3)**2*nDp2*nDp3 + 8.D0/(
     &    s(p1,p4))*s(p2,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p4))*s(p2,p3)**2
     &    *nDp3*nDp4 - 16.D0/(s(p1,p4))*s(p2,p3)**2*nDp4**2 + 8.D0/(s(
     &    p1,p4))/(s(p1,p4))*s(p2,p3)**3*nDp4**2 + 8.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp3**2 + 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p2,p3)**3*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,
     &    p3)**3*nDp4**2 - 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4
     &     - 8.D0/(
     & s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 - 16.D0/(s(p3,p4))*s(p1,p2)*
     &    s(p2,p3)*nDp3*nDp4 - 16.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp3**2 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 8.D0/(s(p3,
     &    p4))*s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp3
     &    *nDp4 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp3**2 + 16.D0/(s(p3,p4)
     &    )*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3)*nDp2*nDp4 + 8.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3*
     &    nDp4 + 16.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3**2 - 8.D0/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p3)*nDp4**2 + 8.D0/(s(p3,p4))*s(p2,p3)
     &    **2*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp4 - 8.D0
     &    /(s(p3,p4))*s(p2,p3)**2*nDp3*nDp4 + 8.D0/(s(p3,p4))*s(p2,p3)
     &    **2*nDp3**2 - 16.D0/(s(p3,p4))*s(p2,p3)**2*nDp4**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 16.D0*s(p1,p2)*nDp2*
     &    nDp3 + 21.D0*s(p1,p2)*nDp2*nDp4 - 6.D0*s(p1,p2)*nDp3*nDp4 - 
     &    s(p1,p2)*nDp3**2 - 25.D0/2.D0*s(p1,p2)*nDp4**2 - 25.D0/2.D0*
     &    s(p1,p3)*nDp2*nDp4 - 14.D0*s(p1,p3)*nDp2**2 + 5.D0*s(p1,p3)*
     &    nDp3*nDp4 + 4.D0*s(p1,p3)*nDp3**2 - 9.D0/2.D0*s(p1,p3)*
     &    nDp4**2 + 13.D0*s(p1,p4)*nDp2*nDp3 + 27.D0*s(p1,p4)*nDp2*nDp4
     &     - 11.D0*s(p1,p4)*nDp2**2 - 3.D0/2.D0*s(p1,p4)*nDp3*nDp4 - 6.D
     &    0*s(p1,p4)*nDp3**2 - 5.D0/2.D0*s(p1,p4)*nDp4**2 + 4.D0*s(p2,
     &    p3)*nDp2*nDp3 - 17.D0/2.D0*s(p2,p3)*nDp2*nDp4 - s(p2,p3)*
     &    nDp2**2 - 4.D0*s(p2,p3)*nDp3*nDp4 + 9.D0/2.D0*s(p2,p3)*
     &    nDp4**2 + 17.D0*s(p2,p4)*nDp2*nDp3 + 21.D0*s(p2,p4)*nDp2*nDp4
     &     - 19.D0/2.D0*s(p2,p4)*nDp3*nDp4 - s(p2,p4)*nDp3**2 - 5.D0/2.D
     &    0*s(p2,p4)*nDp4**2 - 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 - 
     &    25.D0/2.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp4 + 3.D0/(s(p1,p2))
     &    *s(p1,p3)**2*nDp2**2 + 2.D0/(s(p1,p2))*s(p1,p3)**2*nDp4**2 + 
     &    9.D0/(
     & s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 17.D0/2.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*nDp2*nDp4 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    *nDp2**2 - 1/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 4.D0/(
     &    s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp4**2 - 4.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p2,p3)*nDp2*nDp3 - 43.D0/2.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3
     &    )*nDp2*nDp4 - 5.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2**2 + 10.D
     &    0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 21.D0/2.D0/(s(p1,
     &    p2))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 15.D0/(s(p1,p2))*s(p1,p3)*
     &    s(p2,p4)*nDp2**2 - 1/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp3*nDp4
     &     + 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp4**2 + 9.D0/2.D0/(s(
     &    p1,p2))*s(p1,p4)**2*nDp2*nDp3 + 6.D0/(s(p1,p2))*s(p1,p4)**2*
     &    nDp2*nDp4 - 29.D0/2.D0/(s(p1,p2))*s(p1,p4)**2*nDp2**2 - 4.D0
     &    /(s(p1,p2))*s(p1,p4)**2*nDp3*nDp4 - 1/(s(p1,p2))*s(p1,p4)**2*
     &    nDp3**2 + 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 19.D0/
     &    2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 + 4.D0/(s(p1,p2))
     &    *s(p1,p4)*s(p2,p3)*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 12.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p4)*nDp2*nDp3 + 6.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp4 - 11.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0
     &    /(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp3*nDp4 - 1/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**3
     &    *nDp2**2 - 3.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3)*
     &    nDp2**2 - 3.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp4 - 7.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2**2 + 3.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*
     &    nDp2*nDp3 - 9.D0/2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    **2*nDp2*nDp4 - 7.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    **2*nDp2**2 + 9.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(
     &    p2,p3)*nDp2**2 + 3.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    *s(p2,p4)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 9.D0/2.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 12.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 9.D0/
     &    2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**3*nDp2*nDp3 - 7.D0/2.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p4)**3*nDp2**2 + 5.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 9.D0/2.D0/(s(p1,p2
     &    ))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 - 7.D0/2.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp2**2 - 1/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)*nDp2*nDp4 - 1/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2*
     &    nDp4 + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4
     &    )**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p1,p4)**2*nDp2*nDp4 + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4)**2*nDp2**2 + 1/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 2.D0/(
     &    s(p1,p2))/(
     & s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 
     &    1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*
     &    nDp2**2 - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4)**3*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)**3*nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp2**2 - 2.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,
     &    p4)*nDp2*nDp4 + 5.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 3.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**4*nDp2*nDp3 - 4.D0/(s(p1
     &    ,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*nDp2*nDp3 + 
     &    4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*
     &    s(p2,p4)**2*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 1.D0/2.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)**2*nDp2*
     &    nDp4 + 1.D0/2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**3*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 1.D0/2.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**3*
     &    nDp2*nDp3 - 1.D0/2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4)**3*nDp2**2 - 1.D0/2.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*s(p2,
     &    p4)*nDp2*nDp3 - 1.D0/2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*s(p2,p4)*nDp2**2 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4)*nDp2**2 + 
     &    4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3)*
     &    nDp2**2 - 9.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*
     &    s(p1,p4)**2*nDp2**2 + 5.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p1,p4)*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1
     &    ,p2))/(
     & s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2*nDp2**2 - 5.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3*nDp2**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)*
     &    nDp2**2 + 9.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1
     &    ,p4)*s(p2,p3)**2*nDp2**2 - 5.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**3*s(p2,p3)*nDp2**2 + 5.D0/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*nDp2**2 + 4.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)**3*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p4))
     &    *s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 + 4.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**2*s(p2,p4)*nDp4**2 - 1/(s(p1,p2))/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p3)**3*s(p2,p4)*nDp2*nDp4 + 1/(s(p1,p2))/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp2*nDp4 + 4.D0/(s(p1,p2))
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3)*nDp2**2 - 4.D0/(
     &    s(p1,p2))/(
     & s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2*nDp2*nDp4 - 2.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp2*nDp4 + 1/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 + 15.D0/2.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 - 1/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 - 1/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4)*nDp3*nDp4 - 5.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4)*nDp4**2 - 3.D0/2.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 3.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 1/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p3)**2*s(p2,p4)*nDp3*nDp4 - 5.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4)*nDp4**2 - 11.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 13.D0/2.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 + 13.D0/2.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp3*nDp4 + 1/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2*nDp3**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp4**2 - 1/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 9.D0/2.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1
     &    ,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 13.D0/2.
     &    D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp3*nDp4
     &     + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp3**2
     &     - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp4**2 - 7.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*
     &    nDp2*nDp4 - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*
     &    nDp2**2 - 23.D0/2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp3*nDp4 - 3.D0
     &    /2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp3**2 - 15.D0/2.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 - 8.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp4 + 6.D0
     &    /(
     & s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp3*nDp4 - 3.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp3**2 - 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp4 + 2.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)*nDp2**2 - 1.D0
     &    /2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*
     &    nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3
     &    *s(p2,p4)*nDp2**2 - 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p3)**2*s(p1,p4)**2*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*nDp2**2 + 1.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*nDp3*
     &    nDp4 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1
     &    ,p4)**2*nDp4**2 + 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 1/(s(p1,p2))/(s(p2,
     &    p3))/(
     & s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 11.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)
     &    *nDp2**2 + 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )**2*s(p1,p4)*s(p2,p4)*nDp3*nDp4 + 2.D0/(s(p1,p2))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp4**2 + 1.D0/2.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*
     &    nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2
     &    *s(p2,p4)**2*nDp2**2 + 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**3*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp3*nDp4 - 1.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp3**2
     &     + 1/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(
     &    p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)*s(p1,p4)**2*s(p2,p4)*nDp2*nDp4 - 1.D0/2.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*nDp2**2 - 
     &    4.D0/(
     & s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*
     &    nDp3*nDp4 - 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)**2*s(p2,p4)*nDp3**2 - 1.D0/2.D0/(s(p1,p2))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 4.D
     &    0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)
     &    **2*nDp2*nDp4 + 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp2**2 + 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**4*nDp3**2 - 4.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*nDp2*nDp3 + 2.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*
     &    nDp3**2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*
     &    s(p2,p4)**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p4)**2*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)**3*nDp2**2 - 8.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**3*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 + 11.D0/2.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 - 21.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp3 - 3.D0/2.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2 + 12.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 11.D0/2.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp4 - 14.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 8.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp4 - 3.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp3 - 27.D
     &    0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp4
     &     + 3.D0/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 + 4.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**3*nDp2*nDp3 + 19.D0/2.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp4 - 9.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2**2 - 4.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2*nDp3 - 19.D0/2.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2*nDp4 + 4.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp2**2 + 3.D0/(s(p1,p4)
     &    )*s(p1,p2)**2*nDp2*nDp3 - 17.D0/2.D0/(s(p1,p4))*s(p1,p2)**2*
     &    nDp3*nDp4 + 4.D0/(s(p1,p4))*s(p1,p2)**2*nDp3**2 - 10.D0/(s(p1
     &    ,p4))*s(p1,p2)**2*nDp4**2 - 5.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)
     &    *nDp2*nDp3 + 13.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp4 - 3.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2**2 + 13.D0/2.D0
     &    /(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 4.D0/(s(p1,p4))*s(
     &    p1,p2)*s(p1,p3)*nDp3**2 + 15.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1
     &    ,p3)*nDp4**2 + 1/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp2*nDp4 - 4.D0
     &    /(
     & s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp3*nDp4 + 9.D0/2.D0/(s(p1,p4))*s(
     &    p1,p2)*s(p2,p3)*nDp4**2 + 2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*
     &    nDp2*nDp3 - 13.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 10.
     &    D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp4**2 - 8.D0/(s(p1,p4))*s(
     &    p1,p3)**2*nDp2*nDp3 - 17.D0/2.D0/(s(p1,p4))*s(p1,p3)**2*nDp2*
     &    nDp4 + 1/(s(p1,p4))*s(p1,p3)**2*nDp2**2 + 5.D0/2.D0/(s(p1,p4)
     &    )*s(p1,p3)**2*nDp4**2 + 5.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp4 + 4.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp3*nDp4 + 25.D
     &    0/2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp4**2 + 2.D0/(s(p1,p4))
     &    *s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 11.D0/(s(p1,p4))*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 - 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 - 
     &    6.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 1/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp4**2 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **3*nDp3*nDp4 + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*
     &    nDp2*nDp4 - 7.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,
     &    p3)*nDp4**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 1/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 + 7.D0/2.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp4**2 - 3.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 + 1/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp3*nDp4 - 9.D0/2.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp4**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 1/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 1/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp4**2 + 1/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 + 7.D0/2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp4**2 - 3.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)**3*nDp2*nDp4 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp3*nDp4 - 9.D0/2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)*nDp4**2 + 3.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)**2*nDp2*nDp4 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 1/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 + 9.D0/2.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)*s(p2,p4)**2*nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp2*nDp4 + 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp3*nDp4 + 2.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp4**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4)**2*nDp2*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p2,p4)**2*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2*nDp4**2 - 1/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3*nDp2*nDp4 + 3.D0/(
     &    s(p1,p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 + 2.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2
     &    ,p4)*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)**2*s(p2,p4)*nDp4**2 - 3.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 - 4.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2
     &    *nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*s(p2,p4)**2*nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)**3*nDp2*nDp4 + 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*nDp3*nDp4 + 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*nDp4**2 - 1/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2*
     &    nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2
     &    ,p4)**2*nDp2*nDp4 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)*s(p2,p4)**3*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**3*s(p1,p3)*nDp3*nDp4 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2*nDp2*nDp4 - 2.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2*nDp3*
     &    nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )**3*nDp2*nDp4 - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp2*
     &    nDp3 - 9.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp3*nDp4
     &     - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp3**2 + 7.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 + 9.D0/2.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp4 + 1/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2**2 - 21.D0/2.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 - 4.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 17.D0/2.
     &    D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp4**2 + 1/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)*nDp2*nDp3 - 1/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)*nDp2*nDp4 + 1.D0/2.D0/(
     &    s(p1,p4))/(
     & s(p3,p4))*s(p1,p2)**2*s(p2,p3)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p3
     &    ,p4))*s(p1,p2)**2*s(p2,p3)*nDp3**2 - 9.D0/2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p2,p3)*nDp4**2 + 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 + 21.D0/2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 - 3.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2**2 + 2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3*nDp4 - 1.D0/2.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp4**2 - 7.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 3.D0/2.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp2*nDp4 - 
     &    1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp2**2 + 
     &    1.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*
     &    nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2
     &    ,p3)*nDp3**2 - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    s(p2,p3)*nDp4**2 + 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)
     &    **2*nDp2*nDp4 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 4.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p2,p3)**2*nDp3*nDp4 + 9.D0/2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp4**2 - 2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p3)**3*nDp2*nDp4 - 4.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p3)**3*nDp2**2 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(
     &    p2,p3)*nDp2*nDp3 - 1.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**
     &    2*s(p2,p3)*nDp2*nDp4 + 3.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2
     &    *s(p2,p3)*nDp2**2 + 1.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p3)*nDp4**2 - 3.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3)**2*nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3)**2*nDp3*nDp4 + 9.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3
     &    )*s(p2,p3)**2*nDp4**2 + 3.D0/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3
     &     + 1.D0/2.D0/(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4 - 2.D0/(s(p2,p3
     &    ))*s(p1,p2)**2*nDp3**2 + 7.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp3 + 5.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 2.D0
     &    /(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 9.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*nDp3*nDp4 - 17.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp4**2 + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 5.D0/
     &    2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3*nDp4 - 4.D0/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p4)*nDp3**2 + 3.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4
     &    )*nDp2*nDp3 - 9.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*
     &    nDp4 - 1/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 + 2.D0/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 1/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*nDp3**2 + 15.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp4**2
     &     + 2.D0/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp3 - 11.D0/2.D0/(s(p2,
     &    p3))*s(p1,p3)**2*nDp2*nDp4 - 2.D0/(s(p2,p3))*s(p1,p3)**2*
     &    nDp2**2 - 2.D0/(s(p2,p3))*s(p1,p3)**2*nDp3*nDp4 - 19.D0/2.D0
     &    /(s(p2,p3))*s(p1,p3)**2*nDp4**2 + 6.D0/(s(p2,p3))*s(p1,p3)*s(
     &    p1,p4)*nDp2*nDp3 + 29.D0/2.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2*nDp4 - 4.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2**2 + 15.D0/
     &    2.D0/(
     & s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 3.D0/(s(p2,p3))*s(p1,p3)
     &    *s(p1,p4)*nDp3**2 - 9.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp4**2
     &     + 5.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 5.D0/(s(p2,
     &    p3))*s(p1,p3)*s(p2,p4)*nDp2**2 + 10.D0/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp3*nDp4 + 2.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp3**2
     &     - 1.D0/2.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp4**2 - 1.D0/2.D0
     &    /(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 12.D0/(s(p2,p3))*s(p1,p4)
     &    **2*nDp3*nDp4 + 9.D0/2.D0/(s(p2,p3))*s(p1,p4)**2*nDp3**2 - 
     &    1/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 27.D0/2.D0/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp4 + 1/(s(p2,p3))*s(p1,p4)*s(p2
     &    ,p4)*nDp2**2 + 15.D0/2.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3*
     &    nDp4 - 3.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3**2 + 4.D0/(s(p2
     &    ,p3))*s(p1,p4)*s(p2,p4)*nDp4**2 - 11.D0/2.D0/(s(p2,p3))*s(p2,
     &    p4)**2*nDp2*nDp4 - 1/(s(p2,p3))*s(p2,p4)**2*nDp2**2 - 1.D0/2.D
     &    0/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4 - 1/(s(p2,p3))*s(p2,p4)**2
     &    *nDp3**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 4.D0/(s(p2,p3))*s(p2,p4
     &    )**2*nDp4**2 - 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)*nDp3*nDp4 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p2,p4)*nDp3*nDp4 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)**2*nDp2*nDp3 + 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)**2*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)**2*nDp2**2 + 9.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)**2*nDp3*nDp4 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)**2*nDp4**2 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 7.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p1,p4)*nDp3*nDp4 - 5.D0/2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp3**2 + 6.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 5.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 8.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp4**2 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2*nDp3**2 - 3.D0/2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 11.D
     &    0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp3*
     &    nDp4 + 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2
     &    ,p4)*nDp3**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**
     &    2*nDp2*nDp3 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2
     &    *nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*
     &    nDp2**2 + 7.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**
     &    2*nDp3*nDp4 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2
     &    *nDp4**2 - 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2*
     &    nDp4 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2**2 - 5.D0/
     &    2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 - 2.
     &    D0/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 - 5.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 3.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp3*nDp4 + 6.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp4**2 - 3.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 5.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 5.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp3*nDp4 + 4.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp4**2 + 3.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 - 19.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp3*nDp4 - 3.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp3**2 + 7.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 
     &    17.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp4 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)
     &    *s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp3*nDp4 - 5.D0/2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp3**2 - 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp4**2 + 6.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 + 7.D0
     &    /2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 + 
     &    4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 - 5.D0
     &    /2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 - 
     &    4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp4**2 + 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*nDp3**2 - 11.D0/2.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp3*nDp4 + 9.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp3**2 - 9.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 - 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp4 + 1/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)**2*nDp3*nDp4 + 5.D0/2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp3**2 - 3.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p2,p4)**3*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp3**2 - 2.D
     &    0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 4.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 2.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 + 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp3**2 - 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 + 4.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 - 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3*nDp4 - 4.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 2.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp3*nDp4
     &     + 2.D0/(
     & s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp3**2 + 2.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)**2*nDp3**2 + 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p3)**3*nDp2*nDp4 - 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 - 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 2.D0/(s(p3,p4))*s(
     &    p1,p2)**2*nDp2*nDp3 - 5.D0/(s(p3,p4))*s(p1,p2)**2*nDp3*nDp4
     &     - 6.D0/(s(p3,p4))*s(p1,p2)**2*nDp3**2 + 21.D0/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*nDp2*nDp3 + 45.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*nDp2*nDp4 - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2**2
     &     - 13.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 - 10.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 - 1/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p3)*nDp4**2 + 3.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*
     &    nDp3 - 25.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3*nDp4 - 14.
     &    D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3**2 + 1/(s(p3,p4))*s(p1,
     &    p2)*s(p2,p3)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 15.D0/2.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3)*nDp2*nDp4 + 1/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp2**2 + 1.D0/2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3*nDp4 + 
     &    8.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 9.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3)*nDp4**2 + 18.D0/(s(p3,p4))*s(p1,p3)**2*nDp2
     &    *nDp3 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp4 - 15.D0/(s(p3,
     &    p4))*s(p1,p3)**2*nDp2**2 - 1.D0/2.D0/(s(p3,p4))*s(p1,p3)**2*
     &    nDp4**2 + 34.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 31.D0
     &    /2.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 12.D0/(s(p3,p4
     &    ))*s(p1,p3)*s(p1,p4)*nDp2**2 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp3*nDp4 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2 - 1.
     &    D0/2.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp4**2 - 16.D0/(s(p3,p4
     &    ))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 13.D0/2.D0/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p3)*nDp2*nDp4 + 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp4**2 + 12.D0/(
     &    s(p3,p4))*s(p1,p4)**2*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p3,p4))*s(p1
     &    ,p4)**2*nDp3*nDp4 - 4.D0/(s(p3,p4))*s(p1,p4)**2*nDp3**2 + 18.D
     &    0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 - 3.D0/(s(p3,p4))*s(
     &    p1,p4)*s(p2,p3)*nDp2**2 + 4.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*
     &    nDp3**2 - 9.D0/2.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp4**2 - 4.D
     &    0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 - 17.D0/2.D0/(s(p3,p4))*s(
     &    p2,p3)**2*nDp2*nDp4 - 1/(s(p3,p4))*s(p2,p3)**2*nDp2**2 + 4.D0
     &    /(s(p3,p4))*s(p2,p3)**2*nDp3*nDp4 + 9.D0/2.D0/(s(p3,p4))*s(p2
     &    ,p3)**2*nDp4**2 )
      c1234 = c1234 + s124**(-1) * (  - 16.D0*nDp2*nDp3 - 16.D0*nDp2*
     &    nDp4 - 8.D0*nDp3*nDp4 + 8.D0*nDp3**2 - 8.D0/(s(p1,p2))*s(p1,
     &    p3)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*nDp2*nDp4 + 16.D0/(
     &    s(p1,p2))*s(p1,p3)*nDp2**2 - 16.D0/(s(p1,p2))*s(p1,p3)*nDp3*
     &    nDp4 + 8.D0/(s(p1,p2))*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))*
     &    s(p1,p4)*nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)*nDp3**2 - 8.D0/(
     &    s(p1,p2))*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2))*s(p3,p4)*nDp2*
     &    nDp3 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*nDp2**2 + 32.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2**2 + 24.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp2**2 + 16.D0/(s(p1,p2
     &    ))/(s(p1,p2))*s(p2,p3)**2*nDp2**2 + 24.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p2,p3)*s(p3,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p3,p4)**2*nDp2**2 + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p1,p4)*nDp2**2 + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)*nDp2**2 - 3.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 )
      c1234 = c1234 + s124**(-1) * (  - 3.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2**2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*nDp2**2 - 9.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2**2
     &     + 20.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3
     &    )*nDp2**2 - 5.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)**2*nDp2**2 - 9.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 + 24.D0/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 - 5.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 8.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**3*nDp2**2 - 24.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**2*nDp4**2 )
      c1234 = c1234 + s124**(-1) * (  - 56.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p3)*nDp2*nDp4 - 56.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)*s(p3,p4)*nDp2*nDp4 - 32.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)
     &    **2*nDp2*nDp4 - 48.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p3,p4)
     &    *nDp2*nDp4 - 32.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)**2*nDp2*
     &    nDp4 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*
     &    nDp4**2 - 1/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2
     &    ,p4)*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p3,p4)*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p3)**2*s(p3,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)**2*nDp2*nDp4 + 8.D0/(s(p1,
     &    p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)**2*nDp4**2 - 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**3*nDp2*nDp4 + 4.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**3*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*
     &    nDp4 )
      c1234 = c1234 + s124**(-1) * ( 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p2)
     &    )/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 - 8.D0/(
     &    s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**3*nDp2*nDp4 - 9.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp4 + 1/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)**2*nDp2**2 - 16.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)**2*nDp3*nDp4 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*nDp2*nDp3 + 7.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4)*nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)
     &    *nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp3**2 + 7.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*
     &    nDp4 + 5.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp3 - 
     &    16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp4 + 8.D0
     &    /(
     & s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2 - 32.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)**2*nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p4)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(
     &    p2,p4)*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,
     &    p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4)
     &    *nDp3**2 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp4 + 16.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p3,p4)**2*nDp2**2 - 16.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p3,p4)**2*nDp3*nDp4 - 1.D0/2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp4 + 4.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 - 1.D0
     &    /2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp4 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2
     &    *s(p2,p4)*nDp2**2 + 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1) * (  - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp4 + 1.D0/2.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 + 1.D0/2.D
     &    0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)
     &    *nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p3,p4)*nDp2**2
     &     - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2
     &    *nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*s(p3,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p4)**3*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4)*nDp2**2 - 2.D0/(
     &    s(p1,p2))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*s(p3,p4)*nDp2**2
     &     + 11.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp4 - 
     &    12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp2**2 + 12.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 11.D0/2.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 9.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 - 12.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 27.D0/2.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 - 3.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)*s(p2,p3)*nDp2*nDp3 + 19.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p4)*s(p2,p3)*nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)*s(p2,p3)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2
     &    *nDp2*nDp3 + 16.D0/(s(p1,p4))*s(p1,p2)*nDp3*nDp4 + 8.D0/(s(p1
     &    ,p4))*s(p1,p2)*nDp3**2 )
      c1234 = c1234 + s124**(-1) * ( 8.D0/(s(p1,p4))*s(p1,p2)*nDp4**2
     &     - 16.D0/(s(p1,p4))*s(p1,p3)*nDp2*nDp3 - 16.D0/(s(p1,p4))*s(
     &    p1,p3)*nDp2*nDp4 - 8.D0/(s(p1,p4))*s(p1,p3)*nDp3*nDp4 + 8.D0
     &    /(s(p1,p4))*s(p1,p3)*nDp4**2 + 8.D0/(s(p1,p4))*s(p2,p3)*nDp3*
     &    nDp4 - 8.D0/(s(p1,p4))*s(p3,p4)*nDp3*nDp4 + 16.D0/(s(p1,p4))
     &    /(s(p1,p4))*s(p1,p3)**2*nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))
     &    *s(p1,p3)*s(p2,p3)*nDp4**2 + 32.D0/(s(p1,p4))/(s(p1,p4))*s(p1
     &    ,p3)*s(p3,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p3)
     &    **2*nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p3)*s(p3,p4)*
     &    nDp4**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p3,p4)**2*nDp4**2 + 8.
     &    D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*nDp4**2 + 24.D
     &    0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p3,p4)*
     &    nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(
     &    p3,p4)**2*nDp4**2 + 8.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(
     &    p3,p4)**3*nDp4**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp2*nDp4 )
      c1234 = c1234 + s124**(-1) * (  - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)**2*nDp3*nDp4 - 3.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **2*nDp4**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp4 + 7.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3
     &    *nDp4 - 9.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp4**2 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*
     &    nDp4 - 3.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*
     &    nDp4**2 + 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2*
     &    nDp4 + 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp3*
     &    nDp4 - 9.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp4 - 16.D
     &    0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp3*nDp4 - 4.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 1/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 9.D0/2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp4**2 - 24.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp4 - 40.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)*s(p3,p4)*nDp3*nDp4 )
      c1234 = c1234 + s124**(-1) * (  - 24.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p3,p4)**2*nDp2*nDp4 - 32.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**2
     &    *nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p1,p3)*nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 1/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 2.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*
     &    nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3
     &    ,p4)*nDp2*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p3,p4)*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p3,p4)*nDp4**2 - 2.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 + 3.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4
     &     + 4.D0/(
     & s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*
     &    nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p4)*nDp4**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*s(p3,p4)*nDp2*nDp4 - 1/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 - 2.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp4**2 + 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)
     &    *nDp2*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)*s(p3,p4)*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)*nDp4**2 - 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 + 1/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,
     &    p4)*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2
     &    )**2*s(p1,p3)*nDp3*nDp4 )
      c1234 = c1234 + s124**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3*nDp4 + 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*nDp2*nDp4 - 1/(s(p1,p4
     &    ))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 - 9.D0/2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)**2*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p2)**2*nDp3**2 + 7.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*nDp2*nDp3 + 9.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp2*nDp4 + 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*nDp2**2 + 7.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)
     &    *nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp3**2 - 1.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp4**2 - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp2*nDp4
     &     + 12.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3*nDp4 + 
     &    16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 9.D0/
     &    2.D0/(
     & s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp4**2 - 8.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 7.D0/2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p3)**2*nDp2*nDp4 - 3.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p3)**2*nDp2**2 - 1.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)
     &    **2*nDp4**2 - 32.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp3 - 13.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3
     &    *nDp4 + 7.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp4**2 - 16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3
     &     - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp4 + 16.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p2,p3)**2*nDp3*nDp4 + 16.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p2,p3)**2*nDp4**2 - 11.D0/(s(p2,p3))*s(p1,p2)*
     &    nDp2*nDp3 - 13.D0/2.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp4 - 11.D0/
     &    2.D0/(s(p2,p3))*s(p1,p2)*nDp3*nDp4 - 7.D0/(s(p2,p3))*s(p1,p2)
     &    *nDp3**2 - 11.D0/2.D0/(s(p2,p3))*s(p1,p2)*nDp4**2 + 8.D0/(s(
     &    p2,p3))*s(p1,p3)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1) * ( 11.D0/(s(p2,p3))*s(p1,p3)*nDp2*
     &    nDp4 + 5.D0/(s(p2,p3))*s(p1,p3)*nDp2**2 + 7.D0/(s(p2,p3))*s(
     &    p1,p3)*nDp3*nDp4 + 8.D0/(s(p2,p3))*s(p1,p3)*nDp3**2 - 9.D0/2.D
     &    0/(s(p2,p3))*s(p1,p3)*nDp4**2 - 11.D0/(s(p2,p3))*s(p1,p4)*
     &    nDp2*nDp3 + 19.D0/2.D0/(s(p2,p3))*s(p1,p4)*nDp2*nDp4 + 1.D0/2.
     &    D0/(s(p2,p3))*s(p1,p4)*nDp3*nDp4 - 7.D0/(s(p2,p3))*s(p1,p4)*
     &    nDp3**2 - 4.D0/(s(p2,p3))*s(p1,p4)*nDp4**2 - 3.D0/(s(p2,p3))*
     &    s(p2,p4)*nDp2*nDp3 + 3.D0/2.D0/(s(p2,p3))*s(p2,p4)*nDp2*nDp4
     &     + 1.D0/2.D0/(s(p2,p3))*s(p2,p4)*nDp3*nDp4 + 1/(s(p2,p3))*s(
     &    p2,p4)*nDp3**2 - 4.D0/(s(p2,p3))*s(p2,p4)*nDp4**2 + 8.D0/(s(
     &    p2,p3))*s(p3,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))*s(p3,p4)*nDp2*
     &    nDp4 - 8.D0/(s(p2,p3))*s(p3,p4)*nDp2**2 + 16.D0/(s(p2,p3))*s(
     &    p3,p4)*nDp3*nDp4 + 16.D0/(s(p2,p3))*s(p3,p4)*nDp3**2 - 3.D0/2.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4 - 6.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 5.D0/2.D0/(s(p2
     &    ,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*nDp2**2 + 13.D0/2.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 8.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*nDp4**2 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p4)*nDp2*nDp3 - 11.D0/2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p4)*nDp3*nDp4 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*nDp3**2 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp2*nDp3 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp4 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)*nDp2**2 - 7.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)*nDp3*nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*nDp4**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*
     &    nDp2*nDp3 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2
     &    *nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2**2 + 2.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp3*nDp4 + 2.D0/(
     &    s(p2,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp4**2 - 5.D0/2.D0/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)**2*nDp2*nDp4 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)**2*nDp2**2 - 11.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*nDp2*nDp3 - 17.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*nDp2*nDp4 - 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)*nDp2**2 + 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)*s(p1,p4)*nDp3*nDp4 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*nDp4**2 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)*nDp2*nDp3 - 7.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)
     &    *nDp2**2 + 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp3*nDp4 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp4
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2 + 11.D
     &    0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 - 4.D0/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p4)**2*nDp3*nDp4 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p4)**2*nDp3**2 + 9.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*
     &    s(p2,p4)*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4
     &    )*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3
     &    *nDp4 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp3**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp2*
     &    nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp2*nDp4
     &     + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp2**2 + 3.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p2,p4)**2*nDp2*nDp4 + 1/(s(p2,p3))/(s(p2,p3))*
     &    s(p2,p4)**2*nDp2**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(
     &    p3,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,
     &    p4)*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 - 2.D
     &    0/(
     & s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p4)*nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)**2*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**
     &    2*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*
     &    nDp2*nDp3 + 3.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 - 17.D0/2.D0/(
     &    s(p3,p4))*s(p1,p2)*nDp3*nDp4 - 8.D0/(s(p3,p4))*s(p1,p2)*
     &    nDp3**2 + 20.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 10.D0/(s(p3,
     &    p4))*s(p1,p3)*nDp2*nDp4 - 3.D0/(s(p3,p4))*s(p1,p3)*nDp2**2 - 
     &    4.D0/(s(p3,p4))*s(p1,p3)*nDp3*nDp4 - 4.D0/(s(p3,p4))*s(p1,p3)
     &    *nDp3**2 - 1.D0/2.D0/(s(p3,p4))*s(p1,p3)*nDp4**2 + 8.D0/(s(p3
     &    ,p4))*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(p1,p4)*nDp3*nDp4
     &     - 4.D0/(s(p3,p4))*s(p1,p4)*nDp3**2 + 4.D0/(s(p3,p4))*s(p2,p3
     &    )*nDp2*nDp3 + 17.D0/2.D0/(s(p3,p4))*s(p2,p3)*nDp2*nDp4 + 1/(
     &    s(p3,p4))*s(p2,p3)*nDp2**2 )
      c1234 = c1234 + s124**(-1) * (  - 4.D0/(s(p3,p4))*s(p2,p3)*nDp3*
     &    nDp4 - 9.D0/2.D0/(s(p3,p4))*s(p2,p3)*nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 9.D0*s(p1,p2)*nDp2*nDp3
     &     - 17.D0/2.D0*s(p1,p2)*nDp2*nDp4 - s(p1,p2)*nDp2**2 - 27.D0/2.
     &    D0*s(p1,p2)*nDp3*nDp4 + 14.D0*s(p1,p2)*nDp3**2 - 5.D0/2.D0*s(
     &    p1,p2)*nDp4**2 - 33.D0/2.D0*s(p1,p3)*nDp2*nDp3 - 6.D0*s(p1,p3
     &    )*nDp2*nDp4 - 25.D0/2.D0*s(p1,p3)*nDp2**2 - 3.D0/2.D0*s(p1,p3
     &    )*nDp3*nDp4 - 11.D0*s(p1,p3)*nDp3**2 - 3.D0*s(p1,p3)*nDp4**2
     &     - 7.D0*s(p1,p4)*nDp2*nDp3 - 12.D0*s(p1,p4)*nDp2*nDp4 + 2.D0*
     &    s(p1,p4)*nDp2**2 + 19.D0/2.D0*s(p1,p4)*nDp3*nDp4 - 9.D0*s(p1,
     &    p4)*nDp3**2 + 21.D0*s(p2,p3)*nDp2*nDp3 + 11.D0*s(p2,p3)*nDp2*
     &    nDp4 - 3.D0*s(p2,p3)*nDp2**2 - 21.D0/2.D0*s(p2,p3)*nDp3*nDp4
     &     + 9.D0*s(p2,p3)*nDp3**2 + 11.D0/2.D0*s(p2,p3)*nDp4**2 + 3.D0/
     &    2.D0*s(p2,p4)*nDp2*nDp3 + s(p2,p4)*nDp2*nDp4 - 4.D0*s(p2,p4)*
     &    nDp2**2 - 39.D0/2.D0*s(p2,p4)*nDp3*nDp4 + 19.D0/2.D0*s(p2,p4)
     &    *nDp3**2 + 5.D0/2.D0*s(p2,p4)*nDp4**2 + 10.D0/(s(p1,p2))*s(p1
     &    ,p3)**2*nDp2*nDp3 + 15.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp4 + 
     &    7.D0/(
     & s(p1,p2))*s(p1,p3)**2*nDp2**2 + 1/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    nDp2*nDp3 + 10.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 + 14.
     &    D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2**2 - 8.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p3)*nDp2*nDp3 - 17.D0/2.D0/(s(p1,p2))*s(p1,p3)*s(
     &    p2,p3)*nDp2*nDp4 - 6.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2**2
     &     - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp3**2 - 8.D0/(s(p1,p2)
     &    )*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 - 3.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2**2 + 
     &    8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp4**2 - 7.D0/(s(p1,p2))*
     &    s(p1,p4)**2*nDp2*nDp3 + 9.D0/(s(p1,p2))*s(p1,p4)**2*nDp2**2
     &     + 7.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 3.D0/2.D0/(
     &    s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 - 4.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p3)*nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*
     &    nDp3**2 + 13.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 1.D0/
     &    2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 5.D0/(s(p1,p2))
     &    *s(p1,p4)*s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 3.D0/2.D0/(s(p1,p2))
     &    *s(p2,p3)**2*nDp2*nDp4 + 8.D0/(s(p1,p2))*s(p2,p3)**2*nDp3**2
     &     - 3.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,
     &    p2))*s(p2,p3)*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p2))*s(p2,p3)*
     &    s(p2,p4)*nDp3**2 - 3.D0/(s(p1,p2))*s(p2,p4)**2*nDp2*nDp3 - 1.D
     &    0/2.D0/(s(p1,p2))*s(p2,p4)**2*nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)**3*nDp2*nDp3 + 5.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**3*nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*
     &    nDp2**2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*
     &    nDp2*nDp3 - 5.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*
     &    nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*
     &    nDp2**2 - 3.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp3 + 3.D0/2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,
     &    p4)*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,
     &    p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)
     &    *nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 1/(s(p1,p2))/(s(p1,p4))
     &    *s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2*nDp3 - 11.D0/2.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2*nDp4 - 8.D0/(s(p1
     &    ,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp4**2 + 1/(s(p1
     &    ,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp4**2 - 1/(s(p1,p2))/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2*nDp4 + 7.D0/2.D
     &    0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*
     &    nDp2*nDp4 - 5.D0/2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)*s(p2,p4)**3*nDp2*nDp4 + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **3*nDp2**2 - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)
     &    *nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp3 + 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 9.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 1/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp4 + 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 3.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 + 3.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 - 5.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2**2 - 3.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 6.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 3.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 - 1/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p4)*s(p2,p4)**2*nDp2**2 + 1/(s(p1,p4))*s(p1,p2)**2*nDp2
     &    *nDp4 + 1/(s(p1,p4))*s(p1,p2)**2*nDp3*nDp4 + 4.D0/(s(p1,p4))*
     &    s(p1,p2)**2*nDp4**2 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp3 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 2.D0/(s(p1,p4))*s(p1
     &    ,p2)*s(p1,p3)*nDp2*nDp4 - 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp3*nDp4 - 1.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp4**2 + 
     &    4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp2*nDp3 - 2.D0/(s(p1,p4))
     &    *s(p1,p2)*s(p2,p3)*nDp2*nDp4 + 19.D0/(s(p1,p4))*s(p1,p2)*s(p2
     &    ,p3)*nDp3*nDp4 + 13.D0/2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp4**2 + 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 9.D0/
     &    2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 + 29.D0/2.D0/(s(
     &    p1,p4))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 + 21.D0/2.D0/(s(p1,p4))*
     &    s(p1,p2)*s(p2,p4)*nDp4**2 - 2.D0/(s(p1,p4))*s(p1,p3)**2*nDp2*
     &    nDp3 + 4.D0/(s(p1,p4))*s(p1,p3)**2*nDp2*nDp4 + 2.D0/(s(p1,p4)
     &    )*s(p1,p3)**2*nDp2**2 - 11.D0/(s(p1,p4))*s(p1,p3)**2*nDp3*
     &    nDp4 - 2.D0/(s(p1,p4))*s(p1,p3)**2*nDp3**2 - 3.D0/(s(p1,p4))*
     &    s(p1,p3)**2*nDp4**2 + 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp2*
     &    nDp3 - 3.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 - 2.D0/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p3)*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 10.D0/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p3)*nDp3*nDp4 + 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp3**2 + 17.D0/2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp4**2 + 
     &    1/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)
     &    *nDp2**2 + 17.D0/2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4
     &     + 3.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 23.D0/2.D0/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p4)*nDp4**2 + 1/(s(p1,p4))*s(p2,p3)**2*
     &    nDp3*nDp4 - 11.D0/2.D0/(s(p1,p4))*s(p2,p3)**2*nDp4**2 + 1/(s(
     &    p1,p4))*s(p2,p3)*s(p2,p4)*nDp2*nDp3 - 11.D0/2.D0/(s(p1,p4))*
     &    s(p2,p3)*s(p2,p4)*nDp2*nDp4 + 13.D0/2.D0/(s(p1,p4))*s(p2,p3)*
     &    s(p2,p4)*nDp3*nDp4 - 1/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp3**2
     &     - 8.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp4**2 + 1/(s(p1,p4))*
     &    s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p4))*s(p2,p4)**2*nDp3*nDp4
     &     - 1/(s(p1,p4))*s(p2,p4)**2*nDp3**2 - 5.D0/2.D0/(s(p1,p4))*s(
     &    p2,p4)**2*nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 1/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)**3*nDp3*nDp4 + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*nDp2*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p2,p4)*nDp2*nDp4 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,
     &    p4)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,
     &    p4)*nDp4**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2
     &    *nDp2*nDp4 - 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*
     &    nDp3*nDp4 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*
     &    nDp4**2 + 19.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    s(p2,p4)*nDp2*nDp4 + 3.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 6.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4)*nDp4**2 - 3.D0/2.D0/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 + 5.D0/2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 + 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 1/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)**3*nDp2*nDp4 - 1.D0/2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 - 3.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)*nDp3*nDp4 - 6.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)*nDp4**2 + 6.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)**2*nDp2*nDp4 + 3.D0/2.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)**2*nDp4**2 - 5.D0/2.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p2,p4)**3*nDp2*nDp4 + 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp3*nDp4 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)**3*s(p1,p3)*nDp3*nDp4 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)**3*s(p2,p4)*nDp3*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp2*nDp4 - 1/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp3*nDp4 - 2.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp2*nDp4 + 3.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,
     &    p4)*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )**2*s(p1,p3)*s(p2,p4)*nDp4**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2*nDp3*nDp4 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp2*
     &    nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )**2*s(p2,p4)*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp4**2 + 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4
     &     + 3.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)**2*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp4**2 - 1/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*nDp3*nDp4 - 2.D0/(s(p1,p4)
     &    )/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp2*nDp4 - 1/(s(p1
     &    ,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp3*nDp4
     &     - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)
     &    **2*nDp4**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**3*nDp2*nDp4 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)**3*nDp3*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp4**2 - 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p3)*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p2,p3)**2*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p2,p3)**2*nDp4**2 + 2.D0/(s(p2,p3))*s(p1,p2)
     &    **2*nDp3*nDp4 - 5.D0/(s(p2,p3))*s(p1,p2)**2*nDp3**2 - 2.D0/(
     &    s(p2,p3))*s(p1,p2)**2*nDp4**2 + 15.D0/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*nDp2*nDp3 - 17.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp4 + 31.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3*nDp4
     &     + 18.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3**2 - 10.D0/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*nDp4**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 2.D0/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p4)*nDp2*nDp3 - 5.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)*nDp2*nDp4 + 21.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3*
     &    nDp4 + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3**2 - 4.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p4)*nDp4**2 - 7.D0/2.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp3 - 1.D0/2.D0/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*nDp2*nDp4 - 1/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 - 19.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 23.D0/2.D0/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)*nDp3**2 - 13.D0/2.D0/(s(p2,p3))*s(p1,p3)
     &    **2*nDp2*nDp3 + 5.D0/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp4 - 13.D0/
     &    2.D0/(s(p2,p3))*s(p1,p3)**2*nDp2**2 + 7.D0/2.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)*nDp2*nDp3 + 23.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4
     &    )*nDp2*nDp4 + 19.D0/2.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2**2
     &     + 1.D0/2.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 39.D0/2.
     &    D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 3.D0/2.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp3*nDp4 + 1.D0/2.D0/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp3**2 - 6.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp4**2 - 
     &    6.D0/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 9.D0/(s(p2,p3))*s(p1,
     &    p4)**2*nDp2*nDp4 + 4.D0/(s(p2,p3))*s(p1,p4)**2*nDp2**2 + 13.D0
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 19.D0/2.D0/(s(p2,p3
     &    ))*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 1.D0/2.D0/(s(p2,p3))*s(p1,p4
     &    )*s(p2,p4)*nDp2**2 + 9.D0/2.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp3*nDp4 + 1.D0/2.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3**2 - 
     &    3.D0/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 3.D0/(s(p2,p3))*s(p2,
     &    p4)**2*nDp2*nDp4 - 1/(s(p2,p3))*s(p2,p4)**2*nDp2**2 - 7.D0/(
     &    s(p2,p3))*s(p2,p4)**2*nDp3*nDp4 + 1/(s(p2,p3))*s(p2,p4)**2*
     &    nDp3**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3*nDp4 - 3.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp4 + 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 5.D0
     &    /(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 4.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 1/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp4 + 5.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp3*nDp4 + 5.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp3**2 - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp4**2 + 1/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p2,p4)*nDp2*nDp4 - 3.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 5.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p2,p4)*nDp4**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)**2*nDp2*nDp3 - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)**2*nDp2*nDp4 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1
     &    ,p3)**2*nDp2**2 - 7.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*s(p1,p4)*nDp2*nDp4 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*s(p1,p4)*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 9.D0/2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 7.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 
     &    1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2 + 
     &    3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3*
     &    nDp4 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2
     &    ,p4)*nDp3**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    s(p2,p4)*nDp4**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)**2*nDp2*nDp3 + 5.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)**2*nDp2*nDp4 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)
     &    **2*nDp2**2 + 7.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)*s(p2,p4)*nDp2*nDp3 - 11.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p4)*s(p2,p4)*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2**2 + 5.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp3*nDp4 + 3.D0/2.D0/(s(p2,p3)
     &    )/(
     & s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp3**2 - 1.D0/2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 + 1.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 - 4.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 - 3.D0/2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3**2 + 1/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 1.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 7.D0/2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 + 3.D0/
     &    2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 4.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 7.
     &    D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2
     &    *nDp4 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 - 11.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)
     &    **2*nDp2*nDp4 - 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)**2*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 1/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 - 3.D0/2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp4**2 - 3.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)**3*nDp2**2 - 9.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 7.D0/2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 5.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 - 1.D0/2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 - 3.D0/2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp3**2 - 1.D0/2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p2,p4)**3*nDp2*nDp3 + 3.D0/2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p2,p4)**3*nDp3**2 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2
     &    )**2*s(p1,p3)*nDp3*nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p3)**2*nDp2*nDp3 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)**2*nDp2*nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)**2*nDp3*nDp4 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 8.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)**2*nDp3**2 - 8.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)**3*nDp2*nDp3 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **3*nDp2*nDp4 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*
     &    nDp2**2 + 16.D0/(s(p3,p4))*s(p1,p2)**2*nDp3*nDp4 + 16.D0/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 16.D0/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)*nDp2*nDp4 + 40.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp3*nDp4 + 32.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 + 8.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp4**2 + 8.D0/(s(p3,p4))*s(p1,
     &    p2)*s(p2,p3)*nDp2*nDp3 - 8.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp2*nDp4 + 24.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3*nDp4 + 24.
     &    D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 8.D0/(s(p3,p4))*s(
     &    p1,p3)**2*nDp2*nDp3 - 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp4
     &     - 16.D0/(s(p3,p4))*s(p1,p3)**2*nDp2**2 + 8.D0/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)
     &    *nDp2*nDp4 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 8.D0/(s(p3,p4))*s(p1
     &    ,p3)*s(p2,p3)*nDp2**2 + 8.D0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3
     &     + 8.D0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp4 + 16.D0/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3*nDp4 + 8.D0/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3**2 + 8.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp4**2 + 32.D0/(s(p3,p4))/(s(p3
     &    ,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp3*nDp4 + 16.D0/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp3**2 + 16.D0/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp4**2 + 16.D0/(
     &    s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp3*nDp4 + 8.D0/(
     &    s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp3**2 + 8.D0/(s(
     &    p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp4**2 )
      c1234 = c1234 + s134**(-1) * ( 11.D0*nDp2*nDp3 - 3.D0*nDp2*nDp4
     &     + 19.D0*nDp2**2 + 19.D0/2.D0*nDp3*nDp4 + 15.D0*nDp3**2 - 16.D
     &    0/(s(p1,p2))*s(p1,p3)*nDp2*nDp3 + 10.D0/(s(p1,p2))*s(p1,p3)*
     &    nDp2*nDp4 - 2.D0/(s(p1,p2))*s(p1,p3)*nDp2**2 - 7.D0/(s(p1,p2)
     &    )*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))*s(p1,p4)*nDp2**2 + 8.D0
     &    /(s(p1,p2))*s(p2,p3)*nDp2*nDp3 + 3.D0/2.D0/(s(p1,p2))*s(p2,p3
     &    )*nDp2*nDp4 + 8.D0/(s(p1,p2))*s(p2,p3)*nDp2**2 + 19.D0/(s(p1,
     &    p2))*s(p2,p4)*nDp2*nDp3 + 1.D0/2.D0/(s(p1,p2))*s(p2,p4)*nDp2*
     &    nDp4 + 16.D0/(s(p1,p2))*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)**2*nDp2*nDp3 + 5.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*nDp2*nDp4 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**
     &    2*nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 1/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3
     &     - 5.D0/2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*
     &    nDp4 )
      c1234 = c1234 + s134**(-1) * (  - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1
     &    ,p3)*s(p2,p4)*nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)
     &    **2*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)
     &    *nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**2*nDp2*
     &    nDp4 - 1/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4
     &    )*nDp2*nDp4 + 5.D0/2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p3)*s(p2,p4)**2*nDp2*nDp4 + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4
     &     - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 5.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp2**2 - 3.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 1/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)*nDp2**2 - 24.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **2*nDp2*nDp4 )
      c1234 = c1234 + s134**(-1) * (  - 16.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p3)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp3*nDp4 + 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp3**2 + 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*
     &    nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp4
     &     + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 8.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 - 8.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p2,p3)**2*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p2,
     &    p3)*s(p2,p4)*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)
     &    *s(p2,p4)*nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2
     &    *nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*nDp2*
     &    nDp4 )
      c1234 = c1234 + s134**(-1) * ( 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 + 8.D0/(s(p1,
     &    p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2 + 16.D
     &    0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp3*
     &    nDp4 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2
     &    ,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p3)*nDp4**2 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))
     &    *s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 16.D0/(
     &    s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp3*
     &    nDp4 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2
     &    ,p4)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p4)*nDp4**2 + 12.D0/(s(p1,p4))*s(p1,p2)*nDp2*nDp3 - 
     &    22.D0/(
     & s(p1,p4))*s(p1,p2)*nDp2*nDp4 - 3.D0/(s(p1,p4))*s(p1,p2)*nDp3*
     &    nDp4 + 3.D0/2.D0/(s(p1,p4))*s(p1,p2)*nDp4**2 - 2.D0/(s(p1,p4)
     &    )*s(p1,p3)*nDp2*nDp3 - 5.D0/(s(p1,p4))*s(p1,p3)*nDp2*nDp4 - 6.
     &    D0/(s(p1,p4))*s(p1,p3)*nDp2**2 - 11.D0/(s(p1,p4))*s(p1,p3)*
     &    nDp3*nDp4 - 2.D0/(s(p1,p4))*s(p1,p3)*nDp3**2 - 19.D0/(s(p1,p4
     &    ))*s(p1,p3)*nDp4**2 + 32.D0/(s(p1,p4))*s(p2,p3)*nDp2*nDp3 - 
     &    24.D0/(s(p1,p4))*s(p2,p3)*nDp2*nDp4 + 15.D0/(s(p1,p4))*s(p2,
     &    p3)*nDp3*nDp4 - 5.D0/2.D0/(s(p1,p4))*s(p2,p3)*nDp4**2 + 15.D0
     &    /(s(p1,p4))*s(p2,p4)*nDp2*nDp3 - 69.D0/2.D0/(s(p1,p4))*s(p2,
     &    p4)*nDp2*nDp4 + 5.D0/2.D0/(s(p1,p4))*s(p2,p4)*nDp3*nDp4 + 1/(
     &    s(p1,p4))*s(p2,p4)*nDp3**2 + 37.D0/2.D0/(s(p1,p4))*s(p2,p4)*
     &    nDp4**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*nDp4**2 + 
     &    24.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp4**2 + 32.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp4**2 + 16.D0/(s(
     &    p1,p4))/(s(p1,p4))*s(p2,p3)**2*nDp4**2 + 24.D0/(s(p1,p4))/(s(
     &    p1,p4))*s(p2,p3)*s(p2,p4)*nDp4**2 )
      c1234 = c1234 + s134**(-1) * ( 16.D0/(s(p1,p4))/(s(p1,p4))*s(p2,
     &    p4)**2*nDp4**2 + 8.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**3*nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)*nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)**2*nDp4**2 + 8.D0/(s(p1,p4))/(s(p1,p4)
     &    )/(s(p2,p3))*s(p2,p4)**3*nDp4**2 - 21.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)**2*nDp2*nDp4 - 13.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2
     &    )**2*nDp3*nDp4 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp4**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4
     &     - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 1/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 - 6.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp4**2 + 16.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 - 37.D0/2.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 + 12.D0/(s(p1,p4))
     &    /(
     & s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 - 31.D0/2.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)*nDp3**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)*nDp4**2 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    **2*nDp2*nDp4 + 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp3*nDp4 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 - 27.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2*
     &    nDp4 - 21.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4
     &     + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3*nDp4
     &     - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &    *nDp2*nDp3 - 10.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*nDp2*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p1,p3)*nDp2**2 - 9.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(
     & s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 6.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 + 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 + 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp2*
     &    nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4)*nDp2**2 + 10.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )**2*s(p2,p4)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)**2*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp4**2 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 2.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4
     &    )*nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*s(p2,p4)*nDp4**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 - 1/(s(p1,p4))/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3*nDp4 - 2.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp4**2 + 8.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 + 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*
     &    nDp4**2 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p4)**2*nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p4)**2*nDp4**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)**3*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p3,p4))*s(p2,p4)**3*nDp4**2 + 16.D0/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p2)**2*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**
     &    2*nDp3**2 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp3**2 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp4**2 + 32.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3*
     &    nDp4 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2
     &     + 16.D0/(
     & s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp4**2 + 16.D0/(s(p1,p4)
     &    )/(s(p3,p4))*s(p2,p3)**2*nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p2,p3)**2*nDp4**2 + 24.D0/(s(p1,p4))/(s(p3,p4))*s(p2,
     &    p3)*s(p2,p4)*nDp3*nDp4 + 24.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)
     &    *s(p2,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**2*
     &    nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**2*nDp4**2
     &     + 17.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp3 - 7.D0/2.D0/(s(p2,p3))
     &    *s(p1,p2)*nDp2*nDp4 + 19.D0/(s(p2,p3))*s(p1,p2)*nDp2**2 + 13.D
     &    0/2.D0/(s(p2,p3))*s(p1,p2)*nDp3*nDp4 + 12.D0/(s(p2,p3))*s(p1,
     &    p2)*nDp3**2 - 12.D0/(s(p2,p3))*s(p1,p2)*nDp4**2 - 1.D0/2.D0/(
     &    s(p2,p3))*s(p1,p3)*nDp2*nDp3 + 14.D0/(s(p2,p3))*s(p1,p3)*nDp2
     &    *nDp4 + 3.D0/2.D0/(s(p2,p3))*s(p1,p3)*nDp2**2 + 17.D0/(s(p2,
     &    p3))*s(p1,p4)*nDp2*nDp4 + 13.D0/(s(p2,p3))*s(p1,p4)*nDp2**2
     &     + 69.D0/2.D0/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 + 31.D0/2.D0/(s(
     &    p2,p3))*s(p2,p4)*nDp2*nDp4 + 25.D0/(s(p2,p3))*s(p2,p4)*
     &    nDp2**2 )
      c1234 = c1234 + s134**(-1) * ( 25.D0/2.D0/(s(p2,p3))*s(p2,p4)*
     &    nDp3*nDp4 + 13.D0/2.D0/(s(p2,p3))*s(p2,p4)*nDp3**2 + 2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 - 7.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 + 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*nDp2**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp3*nDp4 + 5.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3**2 - 
     &    6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp4**2 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 3.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 + 7.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 1/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 9.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p4)*nDp2*nDp4 + 7.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p4)*nDp2**2 + 13.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*nDp2*nDp3 - 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p2,p4)*nDp2*nDp4 + 9.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)*nDp3*nDp4 )
      c1234 = c1234 + s134**(-1) * ( 11.D0/2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)*nDp3**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*nDp2**2 + 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)*nDp2*nDp3 + 7.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)*nDp2*nDp4 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p2,p4)*nDp2**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*
     &    nDp2**2 - 9.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp3 + 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)
     &    *nDp2**2 + 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2*
     &    nDp3 - 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 + 
     &    2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp2*nDp4
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp3*
     &    nDp4 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1
     &    ,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p2)**2*s(p1,p3)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 )
      c1234 = c1234 + s134**(-1) * (  - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3**2 + 4.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)**2*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p2)**2*nDp3*nDp4 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    **2*nDp4**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp4 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp2**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*
     &    nDp4 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2
     &     - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 - 2.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 - 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3*nDp4 - 6.D0/(s(p2
     &    ,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)**2*nDp2**2 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*
     &    s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2
     &    ,p4)*nDp2*nDp4 )
      c1234 = c1234 + s134**(-1) * ( 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3
     &    )*s(p2,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2
     &    ,p4)*nDp3*nDp4 + 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)
     &    *nDp3**2 - 10.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp3
     &     - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp3*nDp4 - 10.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p2,p4)**2*nDp3**2 + 16.D0/(s(p3,p4))*s(p1,p2)*
     &    nDp2*nDp4 + 24.D0/(s(p3,p4))*s(p1,p2)*nDp3*nDp4 - 16.D0/(s(p3
     &    ,p4))*s(p1,p2)*nDp3**2 + 8.D0/(s(p3,p4))*s(p1,p2)*nDp4**2 + 
     &    40.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 - 8.D0/(s(p3,p4))*s(p1,p3
     &    )*nDp2*nDp4 + 8.D0/(s(p3,p4))*s(p1,p3)*nDp2**2 + 24.D0/(s(p3,
     &    p4))*s(p1,p3)*nDp3*nDp4 + 40.D0/(s(p3,p4))*s(p1,p3)*nDp3**2
     &     - 16.D0/(s(p3,p4))*s(p1,p3)*nDp4**2 - 16.D0/(s(p3,p4))*s(p2,
     &    p3)*nDp2*nDp4 + 24.D0/(s(p3,p4))*s(p2,p3)*nDp3*nDp4 + 16.D0/(
     &    s(p3,p4))*s(p2,p3)*nDp3**2 - 8.D0/(s(p3,p4))*s(p2,p3)*nDp4**2
     &     - 16.D0/(
     & s(p3,p4))*s(p2,p4)*nDp2*nDp3 + 24.D0/(s(p3,p4))*s(p2,p4)*nDp3*
     &    nDp4 - 8.D0/(s(p3,p4))*s(p2,p4)*nDp3**2 + 16.D0/(s(p3,p4))*s(
     &    p2,p4)*nDp4**2 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*nDp3*nDp4 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp3**2 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3*
     &    nDp4 - 8.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2
     &     + 8.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 + 16.D
     &    0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 16.D0/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp4 + 32.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p3)**2*nDp3*nDp4 + 16.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p3)**2*nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2
     &    *nDp4**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2
     &    *nDp4 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3*
     &    nDp4 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp4**2
     &     - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 
     &    16.D0/(
     & s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 16.D0/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s234**(-1) * (  - 8.D0*nDp2*nDp3 - 50.D0*nDp2*
     &    nDp4 + 7.D0*nDp2**2 - 12.D0*nDp3*nDp4 + 8.D0*nDp3**2 + 25.D0/
     &    2.D0*nDp4**2 - 14.D0/(s(p1,p2))*s(p1,p3)*nDp2*nDp3 - 81.D0/2.D
     &    0/(s(p1,p2))*s(p1,p3)*nDp2*nDp4 + 7.D0/(s(p1,p2))*s(p1,p3)*
     &    nDp2**2 + 5.D0/(s(p1,p2))*s(p1,p3)*nDp3*nDp4 - 6.D0/(s(p1,p2)
     &    )*s(p1,p3)*nDp4**2 + 3.D0/(s(p1,p2))*s(p1,p4)*nDp2*nDp3 - 18.D
     &    0/(s(p1,p2))*s(p1,p4)*nDp2*nDp4 + 11.D0/(s(p1,p2))*s(p1,p4)*
     &    nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)*nDp3*nDp4 - 3.D0/(s(p1,p2)
     &    )*s(p1,p4)*nDp3**2 + 8.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp3 + 5.D0
     &    /2.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp4 + 12.D0/(s(p1,p2))*s(p2,
     &    p3)*nDp2**2 + 8.D0/(s(p1,p2))*s(p2,p3)*nDp3**2 - 3.D0/(s(p1,
     &    p2))*s(p2,p4)*nDp2*nDp3 - 17.D0/2.D0/(s(p1,p2))*s(p2,p4)*nDp2
     &    *nDp4 + 8.D0/(s(p1,p2))*s(p2,p4)*nDp2**2 - 4.D0/(s(p1,p2))*s(
     &    p2,p4)*nDp3*nDp4 - 1/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*nDp2*
     &    nDp4 + 5.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*nDp2**2 + 1/(s(
     &    p1,p2))/(
     & s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 9.D0/2.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 + 18.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)*s(p1,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p3)*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)*s(p2,p4)*nDp2*nDp4 - 9.D0/2.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p4)**2*nDp2*nDp3 + 15.D0/2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)
     &    **2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*
     &    nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp2*nDp4
     &     - 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2
     &    *s(p1,p4)*nDp2*nDp4 - 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p3)**2*s(p1,p4)*nDp2**2 + 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 )
      c1234 = c1234 + s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 3.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2
     &    ,p4)*nDp2**2 - 1.D0/2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)**3*s(p1,p4)*nDp2*nDp4 + 1.D0/2.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*
     &    nDp2*nDp3 + 1.D0/2.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4)**2*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)**3*nDp2**2 + 11.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 2.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2**2 + 11.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp2**2 )
      c1234 = c1234 + s234**(-1) * ( 3.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**3*nDp2**2 + 1/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2**2 - 2.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)**2*nDp2*nDp3 - 9.D0/(s(p1,p2))/(s(p1,p4
     &    ))*s(p1,p3)**2*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3
     &    )**2*nDp4**2 + 1/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2
     &    *nDp3 - 11.D0/2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 + 1/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*nDp2
     &    *nDp4 - 5.D0/2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**2*nDp2*nDp4 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p3)**3*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 - 27.D0/2.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*nDp2*nDp4 + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **2*nDp2**2 )
      c1234 = c1234 + s234**(-1) * ( 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**
     &    2*nDp3*nDp4 + 5.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*nDp4**2
     &     + 17.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 
     &    5.D0/2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp4
     &     + 22.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2**2 - 13.
     &    D0/2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 - 
     &    1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp3**2 + 4.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp4**2 - 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 3.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 2.D0/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 + 15.D0/2.D0/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p4)**2*nDp2*nDp3 + 5.D0/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p4)**2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp3
     &    *nDp4 + 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp3**2
     &     + 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 
     &    19.D0/(
     & s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p2,p4)**2*nDp2*nDp4 + 1.D0/2.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2*nDp4 - 2.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2**2 - 1.D0/2.D0/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 + 3.D0
     &    /2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2*nDp4 + 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p1,p4)*nDp2**2 - 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp3*nDp4 - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp4**2 - 1.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*
     &    nDp4 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2
     &    ,p4)*nDp2**2 - 3.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp3*nDp4 + 1.D0/2.D0/(s(p1,p2))
     &    /(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp3**2 + 1.D0/2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p1,p4)*s(p2,p4)*nDp2*nDp4 + 1.D0/2.D0/(s(p1,p2))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 - 2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*nDp3**2 + 4.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*
     &    nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4
     &    )**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **3*nDp4**2 - 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p1,p4)*nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p3)**2*s(p1,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp3**2 - 8.D0/(
     &    s(p1,p2))/(
     & s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 67.D0/2.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)**2*nDp2*nDp4 + 12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)**2*nDp2**2 + 12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4
     &    )*nDp2*nDp3 - 51.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp2*nDp4 + 27.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)
     &    *nDp2**2 - 35.D0/2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)
     &    *nDp2*nDp4 + 11.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp3 - 
     &    8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp4 + 4.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2**2 + 12.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 11.D0/2.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp4 + 22.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p3)**3*nDp4**2 - 16.D0/(s(p1,p2))/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp3*nDp4 + 8.D0/(s(p1,p2))/(
     &    s(p3,p4))/(
     & s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp4 - 16.D0/(s(p1,
     &    p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp3*nDp4 + 8.
     &    D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp3**2 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)*s(p2,p3)*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3
     &    ,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp4 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 + 8.D0/(
     &    s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**3*nDp3**2 + 16.D0/(
     &    s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*
     &    nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3
     &    )**2*nDp2**2 + 2.D0/(s(p1,p4))*s(p1,p2)*nDp2*nDp3 + 6.D0/(s(
     &    p1,p4))*s(p1,p2)*nDp2*nDp4 + 24.D0/(s(p1,p4))*s(p1,p2)*nDp3*
     &    nDp4 + 65.D0/2.D0/(s(p1,p4))*s(p1,p2)*nDp4**2 - 14.D0/(s(p1,
     &    p4))*s(p1,p3)*nDp2*nDp4 + 17.D0/(s(p1,p4))*s(p1,p3)*nDp3*nDp4
     &     + 2.D0/(
     & s(p1,p4))*s(p1,p3)*nDp3**2 + 20.D0/(s(p1,p4))*s(p1,p3)*nDp4**2
     &     - 8.D0/(s(p1,p4))*s(p2,p3)*nDp2*nDp4 + 1/(s(p1,p4))*s(p2,p3)
     &    *nDp3*nDp4 - 11.D0/2.D0/(s(p1,p4))*s(p2,p3)*nDp4**2 + 1/(s(p1
     &    ,p4))*s(p2,p4)*nDp2*nDp3 + 5.D0/2.D0/(s(p1,p4))*s(p2,p4)*nDp2
     &    *nDp4 + 11.D0/2.D0/(s(p1,p4))*s(p2,p4)*nDp3*nDp4 - 1/(s(p1,p4
     &    ))*s(p2,p4)*nDp3**2 - 5.D0/2.D0/(s(p1,p4))*s(p2,p4)*nDp4**2
     &     + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 - 5.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)**2*nDp4**2 + 11.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*nDp2*nDp4 + 13.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*nDp3*nDp4 + 51.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*nDp4**2 - 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp2*nDp4 - 9.D0/2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)*nDp3*nDp4 + 1.D0/2.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)*s(p2,p4)*nDp4**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*nDp2*nDp4 )
      c1234 = c1234 + s234**(-1) * ( 1/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**
     &    2*nDp3*nDp4 + 9.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp4**2 + 13.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp4 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp3
     &    *nDp4 + 19.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 - 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2*
     &    nDp4 + 5.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3*nDp4
     &     + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3**2
     &     - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3
     &    )*nDp2*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)*nDp2*nDp4 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3**2 + 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp4**2 - 18.D0/(s(p1
     &    ,p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp3*nDp4 - 16.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*
     &    nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)**2*nDp2**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp3*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp4**2 + 22.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 10.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*s(p2,p4)*nDp4**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)**2*nDp2*nDp4 - 3.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3*nDp4 + 6.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp4**2 + 1/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2*nDp4 + 8.D0/(s(p1
     &    ,p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2**2 + 14.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp4 + 3.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4
     &     + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*
     &    nDp3*nDp4 + 10.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**2*nDp4**2 + 10.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p1,p3)*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 16.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 - 10.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp2*nDp4
     &     + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2
     &    *nDp3*nDp4 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**
     &    3*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **3*nDp2**2 + 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3
     &     + 9.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp3*nDp4 + 4.D
     &    0/(
     & s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 - 7.D0/(s(p1,p4))/(s(p3
     &    ,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 9.D0/2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 1/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*nDp2**2 + 41.D0/2.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*nDp3*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*nDp3**2 + 33.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*nDp4**2 + 9.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)
     &    *s(p2,p3)*nDp2*nDp4 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p3)*nDp3*nDp4 + 41.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*
     &    s(p2,p3)*nDp4**2 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*
     &    nDp2*nDp3 - 41.D0/2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*nDp2
     &    *nDp4 + 3.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*nDp2**2 + 1.D0/
     &    2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*nDp4**2 - 3.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 + 4.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3*nDp4 + 25.D0/2.D0/(s(p1,p4
     &    ))/(
     & s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp4**2 - 8.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p2,p3)**2*nDp2*nDp4 + 2.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp3
     &     + 11.D0/2.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp4 - 1/(s(p2,p3))*s(
     &    p1,p2)*nDp2**2 - 13.D0/(s(p2,p3))*s(p1,p2)*nDp3*nDp4 - 18.D0
     &    /(s(p2,p3))*s(p1,p2)*nDp3**2 + 20.D0/(s(p2,p3))*s(p1,p2)*
     &    nDp4**2 + 3.D0/2.D0/(s(p2,p3))*s(p1,p3)*nDp2*nDp3 - 50.D0/(s(
     &    p2,p3))*s(p1,p3)*nDp2*nDp4 - 15.D0/2.D0/(s(p2,p3))*s(p1,p3)*
     &    nDp2**2 + 7.D0/(s(p2,p3))*s(p1,p3)*nDp3*nDp4 - 2.D0/(s(p2,p3)
     &    )*s(p1,p3)*nDp3**2 + 5.D0/(s(p2,p3))*s(p1,p3)*nDp4**2 + 7.D0
     &    /(s(p2,p3))*s(p1,p4)*nDp2*nDp3 - 25.D0/(s(p2,p3))*s(p1,p4)*
     &    nDp2*nDp4 - 17.D0/(s(p2,p3))*s(p1,p4)*nDp2**2 - 8.D0/(s(p2,p3
     &    ))*s(p1,p4)*nDp3*nDp4 - 14.D0/(s(p2,p3))*s(p1,p4)*nDp3**2 + 
     &    11.D0/2.D0/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p2,p3))*s(
     &    p2,p4)*nDp2*nDp4 - 20.D0/(s(p2,p3))*s(p2,p4)*nDp3*nDp4 + 1.D0/
     &    2.D0/(s(p2,p3))*s(p2,p4)*nDp3**2 + 4.D0/(s(p2,p3))*s(p2,p4)*
     &    nDp4**2 )
      c1234 = c1234 + s234**(-1) * ( 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*nDp2*nDp4 - 5.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3*
     &    nDp4 + 11.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3**2 + 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp4**2 - 28.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 1/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4 - 1/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*nDp2**2 + 3.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*nDp3*nDp4 - 13.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p4)*nDp2*nDp3 - 5.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4)*nDp2*nDp4 - 9.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1
     &    ,p4)*nDp2**2 + 31.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2
     &    ,p4)*nDp2*nDp3 + 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)*nDp2*nDp4 - 45.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)*nDp3*nDp4 + 29.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p2,p4)*nDp3**2 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp2*nDp3 )
      c1234 = c1234 + s234**(-1) * ( 1.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**2*nDp2*nDp4 + 17.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2
     &    *nDp2**2 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp3*
     &    nDp4 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp4**2 - 3.D0/
     &    2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 7.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2**2 + 11.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 5.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp3**2 - 45.D0/2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 - 39.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 + 5.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 4.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp4**2 + 3.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p4)**2*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)**2*nDp3**2 - 10.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(
     &    p2,p4)*nDp2*nDp3 )
      c1234 = c1234 + s234**(-1) * (  - 33.D0/2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p4)*s(p2,p4)*nDp3*nDp4 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)*nDp3**2 + 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p2,p4)**2*nDp2*nDp3 - 12.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2
     &    *nDp2*nDp4 + 1/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2**2 - 16.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3*nDp4 + 3.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 - 8.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)**2*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*nDp3**2 - 14.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*nDp2*nDp3 + 18.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p3)*nDp3*nDp4 - 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)
     &    *nDp3**2 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp4**2 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*
     &    nDp3 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp4
     &     - 16.D0/(
     & s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3*nDp4 - 18.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3**2 + 10.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 18.D0/(s(p2,p3))/(s(p3,p4
     &    ))*s(p1,p3)**2*nDp2*nDp4 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p3)**2*nDp2**2 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*
     &    nDp4**2 + 18.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*
     &    nDp3 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*
     &    nDp4 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2
     &     - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 + 
     &    16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp3 + 8.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p4)**2*nDp2**2 - 19.D0/(s(p3,p4))*s(
     &    p1,p2)*nDp2*nDp3 + 2.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp4 + 9.D0/
     &    2.D0/(s(p3,p4))*s(p1,p2)*nDp3*nDp4 - 32.D0/(s(p3,p4))*s(p1,p2
     &    )*nDp3**2 + 4.D0/(s(p3,p4))*s(p1,p2)*nDp4**2 + 4.D0/(s(p3,p4)
     &    )*s(p1,p3)*nDp2*nDp3 - 54.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp4 + 
     &    19.D0/(
     & s(p3,p4))*s(p1,p3)*nDp2**2 + 32.D0/(s(p3,p4))*s(p1,p3)*nDp3*nDp4
     &     + 4.D0/(s(p3,p4))*s(p1,p3)*nDp3**2 + 25.D0/2.D0/(s(p3,p4))*
     &    s(p1,p3)*nDp4**2 - 8.D0/(s(p3,p4))*s(p1,p4)*nDp2*nDp4 - 22.D0
     &    /(s(p3,p4))*s(p1,p4)*nDp3**2 + 4.D0/(s(p3,p4))*s(p1,p4)*
     &    nDp4**2 - 28.D0/(s(p3,p4))*s(p2,p3)*nDp2*nDp3 - 81.D0/2.D0/(
     &    s(p3,p4))*s(p2,p3)*nDp2*nDp4 - 1/(s(p3,p4))*s(p2,p3)*nDp2**2
     &     - 8.D0/(s(p3,p4))*s(p2,p3)*nDp3*nDp4 - 2.D0/(s(p3,p4))*s(p2,
     &    p3)*nDp3**2 + 9.D0/2.D0/(s(p3,p4))*s(p2,p3)*nDp4**2 - 16.D0/(
     &    s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3*nDp4 - 8.D0/(s(p3
     &    ,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 + 8.D0/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3**2 - 16.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p3)*nDp3*nDp4 - 16.D0/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p2,p3)*nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p3)**2*nDp4**2 - 32.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)*nDp3*nDp4 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p3)*nDp2*nDp4 )
      c1234 = c1234 + s234**(-1) * ( 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p3)*nDp3*nDp4 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    *s(p2,p3)*nDp4**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*
     &    nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*
     &    nDp3 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp3*
     &    nDp4 - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2
     &     - 16.D0/(s(p3,p4))/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 - 16.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp4 )
      c1234 = c1234 - 8.D0/(s(p1,p2))*nDp2*nDp3 - 100.D0/(s(p1,p2))*
     &    nDp2*nDp4 + 36.D0/(s(p1,p2))*nDp2**2 + 52.D0/(s(p1,p2))/(s(p1
     &    ,p2))*s(p1,p3)*nDp2**2 + 52.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)
     &    *nDp2**2 + 48.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)*nDp2**2 + 48.D
     &    0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)*nDp2**2 + 48.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p3,p4)*nDp2**2 - 1/(s(p1,p2))/(s(p1,p2))/(s(p2,p3
     &    ))*s(p1,p3)**2*nDp2**2 + 3.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p3)*s(p1,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*nDp2**2 + 18.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*nDp2**2 + 30.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 + 32.D0/(s(p1,p2))/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2**2 + 24.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 20.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2**2 + 24.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2**2 + 32.D0
     &    /(
     & s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2**2 + 16.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*nDp2**2 + 24.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp2**2
     &     + 16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*nDp2**2
     &     - 96.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*nDp2*nDp4 - 96.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p2,p3)*nDp2*nDp4 - 96.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p2,p4)*nDp2*nDp4 - 96.D0/(s(p1,p2))/(s(p1,p4))*s(p3
     &    ,p4)*nDp2*nDp4 + 1/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    **2*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp4 + 16.D0/(s(p1,p2))
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp4**2 - 16.D0/(s(
     &    p1,p2))/(
     & s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp4 - 24.D0/(s(p1,p2))/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2*nDp4 - 16.D0/(s(
     &    p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**2*nDp2*nDp4 - 8.D0/(
     &    s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,
     &    p4)*nDp2*nDp4 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp4 - 8.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*nDp2*nDp4 + 16.D0/(s(
     &    p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*nDp2**2 - 16.D0/(s(
     &    p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4 + 
     &    16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1
     &    ,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(
     &    p3,p4))*s(p2,p3)**2*nDp2*nDp4 - 24.D0/(s(p1,p2))/(s(p1,p4))/(
     &    s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp2*nDp4
      c1234 = c1234 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**
     & 2*nDp2*nDp4 - 23.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*nDp2*nDp4 + 
     &    11.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*nDp2**2 - 32.D0/(s(p1,p2
     &    ))/(s(p2,p3))*s(p1,p3)*nDp3*nDp4 + 8.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)*nDp4**2 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*nDp2
     &    *nDp3 - 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*nDp2*nDp4 + 16.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)*nDp2**2 - 16.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)*nDp3*nDp4 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p4)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*nDp2*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*nDp2*nDp4 + 16.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p2,p4)*nDp2**2 - 16.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p2,p4)*nDp3*nDp4 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p3,p4)*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)*nDp2*
     &    nDp4 + 32.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)*nDp2**2 - 32.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p3,p4)*nDp3*nDp4 + 1.D0/2.D0/(s(p1,p2)
     &    )/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp4 - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 - 1.D0/2.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(
     &    p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp4 - 1.
     &    D0/2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p3,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)*s(p3,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 16.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*nDp3
     &     - 8.D0/(
     & s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*nDp4 + 16.
     &    D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*
     &    nDp3 - 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*
     &    nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**
     &    2*nDp2**2 - 12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 - 
     &    20.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*nDp2*nDp4 + 32.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*nDp2**2 - 40.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)*nDp2*nDp3 - 36.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*
     &    nDp2*nDp4 + 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*nDp2**2 - 40.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*nDp2*nDp3 - 48.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p2,p3)*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p2,p3)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*
     &    nDp3**2 - 40.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)*nDp2*nDp3 - 64.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)*nDp2*nDp4 + 16.D0/(s(p1,p2)
     &    )/(
     & s(p3,p4))*s(p2,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p3)**2*nDp2*nDp4 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p3)**2*nDp4**2 - 16.D0/(s(p1,p2))/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 32.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3*nDp4 - 16.D0/(s(p1,p2)
     &    )/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 16.D0/(
     &    s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp4
     &     - 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3)*nDp3*nDp4 - 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1
     &    ,p3)*s(p2,p3)*nDp3**2 - 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4)
     &    )*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 - 8.D0/(s(p1,p2))/(s(p3
     &    ,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 16.D0/(s(p1,p2))
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*nDp3**2 + 16.D0/(s(p1,p2))
     &    /(
     & s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2
     &    ))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2 + 8.D0/(s(
     &    p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp3**2 - 96.D
     &    0/(s(p1,p4))*nDp2*nDp4 + 48.D0/(s(p1,p4))*nDp4**2 + 48.D0/(s(
     &    p1,p4))/(s(p1,p4))*s(p1,p2)*nDp4**2 + 48.D0/(s(p1,p4))/(s(p1,
     &    p4))*s(p1,p3)*nDp4**2 + 48.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p3)*
     &    nDp4**2 + 48.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p4)*nDp4**2 + 48.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p3,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp4**2 + 24.D0/(s(p1,p4))/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp4**2 + 32.D0/(s(p1,
     &    p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp4**2 + 24.D0
     &    /(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp4**2
     &     + 16.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp4**2
     &     + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp4**2 + 32.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(
     &    p3,p4)*nDp4**2
      c1234 = c1234 + 16.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**
     & 2*nDp4**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3
     &    ,p4)*nDp4**2 + 16.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p3,p4
     &    )**2*nDp4**2 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*nDp2*nDp3
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*nDp2*nDp4 + 8.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)*nDp2**2 - 6.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)*nDp3*nDp4 + 67.D0/2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)*nDp4**2 - 44.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*nDp2*nDp4
     &     - 31.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*nDp3*nDp4 + 41.D0/2.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p3)*nDp4**2 - 16.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p2,p4)*nDp2*nDp3 - 76.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)*nDp2*nDp4 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*
     &    nDp2**2 - 36.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*nDp3*nDp4 + 16.
     &    D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*nDp4**2 - 72.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p3,p4)*nDp2*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p3,p4)*nDp2**2
      c1234 = c1234 - 48.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)*nDp3*nDp4 + 
     &    8.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)*nDp4**2 + 8.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 + 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp4 + 4.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2**2 + 24.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3*nDp4 + 20.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp3**2 + 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp4**2 - 32.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 18.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp4
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp3*nDp4 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*nDp4**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp3 - 15.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)*nDp2*nDp4 - 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2
      c1234 = c1234 - 14.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     & s(p2,p4)*nDp3*nDp4 - 14.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p3,p4)*nDp2*nDp3 - 17.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2*nDp4 - 8.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2**2 - 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp3*nDp4 - 2.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp4**2 + 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp4 + 16.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 + 15.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp4
     &     + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4
     &    )*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p3,p4)*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p2)*s(p2,p4)*nDp2*nDp4
      c1234 = c1234 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     & s(p2,p4)*nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p2)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)*s(p2,p4)*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3*nDp4 + 8.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp4**2 - 16.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp4 + 16.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp3*nDp4 + 16.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp4**2 - 16.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 - 16.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*nDp2*nDp4 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2
     &    )*nDp3*nDp4 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*nDp3**2 - 
     &    32.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 - 16.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p3)*nDp2*nDp4 + 8.D0/(s(p1,p4))/(s(p3,p4
     &    ))*s(p1,p3)*nDp2**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*
     &    nDp4**2
      c1234 = c1234 - 32.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)*nDp2*nDp3 - 
     &    16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)*nDp2*nDp4 + 16.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p2,p3)*nDp3*nDp4 + 32.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p2,p3)*nDp4**2 - 16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)*
     &    nDp2*nDp3 - 32.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)*nDp2*nDp4 + 
     &    16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)*nDp3*nDp4 + 16.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p2,p4)*nDp4**2 + 23.D0/(s(p2,p3))*nDp2*nDp3
     &     - 99.D0/2.D0/(s(p2,p3))*nDp2*nDp4 - 18.D0/(s(p2,p3))*nDp2**2
     &     - 33.D0/2.D0/(s(p2,p3))*nDp3*nDp4 + 15.D0/(s(p2,p3))*nDp3**2
     &     + 4.D0/(s(p2,p3))*nDp4**2 - 54.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*nDp2*nDp3 - 20.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*nDp2*
     &    nDp4 - 22.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*nDp2**2 + 3.D0/2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*nDp3*nDp4 + 6.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*nDp2*nDp3 + 9.D0/2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*nDp2*nDp4 + 34.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*nDp2**2
      c1234 = c1234 - 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*nDp3*
     & nDp4 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*nDp4**2 - 3.D0/2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p4)*nDp3*nDp4 + 5.D0/2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*
     &    nDp3**2 - 19.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 + 12.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*nDp2*nDp4 - 1/(s(p2,p3))/(
     &    s(p2,p3))*s(p2,p4)*nDp2**2 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p3,
     &    p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p3,p4)*nDp2*nDp4
     &     + 17.D0/(s(p2,p3))/(s(p2,p3))*s(p3,p4)*nDp2**2 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 + 2.D0/(s(p2
     &    ,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 + 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)*nDp2*nDp4 - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2
     &    )*nDp3*nDp4
      c1234 = c1234 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*nDp3**2 - 2.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)*nDp2**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p4)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*nDp2**2
     &     - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp2*nDp3 - 28.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p2,p4)*nDp2*nDp4 + 2.D0/(s(p2,p3))/(s(p3
     &    ,p4))*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*
     &    nDp3*nDp4 - 14.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp3**2 + 8.D
     &    0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp4**2 - 40.D0/(s(p3,p4))*
     &    nDp2*nDp3 - 16.D0/(s(p3,p4))*nDp2*nDp4 + 36.D0/(s(p3,p4))*
     &    nDp3*nDp4 - 6.D0/(s(p3,p4))*nDp3**2 + 16.D0/(s(p3,p4))*
     &    nDp4**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*nDp3**2 - 16.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 - 48.D0/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p3)*nDp3*nDp4 - 16.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p3)*nDp3**2 + 32.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*
     &    nDp3**2
      c1234 = c1234 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p2,p3)*nDp2*nDp3 - 
     &    16.D0/(s(p3,p4))/(s(p3,p4))*s(p2,p3)*nDp3*nDp4 + 16.D0/(s(p3,
     &    p4))/(s(p3,p4))*s(p2,p4)*nDp3**2

      return
      end
